import processing.core.*; 
import processing.xml.*; 

import processing.serial.*; 
import interfascia.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class dsNavConConsole extends PApplet {

/* ////////////////////////////////////////////////////////////////////////////
** File:      dsNavConConsole.pde
 VerCon[] = "dsNavConConsolle 0.9.0 by Guiott 05-09";
 Author:    Guido Ottaviani-->g.ottaviani@mediaprogetti.it<--
** Description: navigation control board remote consolle   
**
-------------------------------------------------------------------------------
Copyright 2009 Guido Ottaviani
g.ottaviani@mediaprogetti.it

    dsNavConConsole is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dsNavConConsole is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with dsNavConConsole.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------    
/////////////////////////////////////////////////////////////////////////////*/



// input text fields
GUIController GuiRun;
IFTextField InputSpeed;
IFTextField InputDist;
IFTextField InputCoordX;
IFTextField InputCoordY;

GUIController GuiConfig;
IFTextField InputSpeed1Kp;
IFTextField InputSpeed1Ki;
IFTextField InputSpeed1Kd;
IFTextField InputSpeed2Kp;
IFTextField InputSpeed2Ki;
IFTextField InputSpeed2Kd;
IFTextField InputAngleKp;
IFTextField InputAngleKi;
IFTextField InputAngleKd;
IFTextField InputDistKp;
IFTextField InputDistKi;
IFTextField InputDistKd;
IFTextField InputAxle;
IFTextField InputWheel1;
IFTextField InputWheel2;
IFTextField InputCpr;
IFTextField InputGear;
IFTextField InputRS232bps;
IFTextField InputRS232Com;

GUIController GuiConfig2;
IFTextField InputMGXmin;
IFTextField InputMGXmax;
IFTextField InputMGYmin;
IFTextField InputMGYmax;
IFTextField InputMGXstep;
IFTextField InputMGYstep;
IFTextField InputMGXSteps;
IFTextField InputMGYSteps;
IFTextField InputMGset;

IFTextField InputDGXmin;
IFTextField InputDGXmax;
IFTextField InputDGYmin;
IFTextField InputDGYmax;
IFTextField InputDGXstep;
IFTextField InputDGYstep;
IFTextField InputDGXSteps;
IFTextField InputDGYSteps;
IFTextField InputDGset;
IFTextField InputCycle;

// buttons
ImageButtons BtnQuit;
ImageButtons BtnRS232;
ImageButtons BtnConfig;
ImageButtons BtnRun;
ImageButtons BtnDet;
ImageButtons BtnSeqL;
ImageButtons BtnSeqR;
ImageButtons BtnSendSpeed;
ImageButtons BtnSendXY;
ImageButtons BtnSendDist;
ImageButtons BtnSendHalt;
ImageButtons BtnSendReset;
ImageButtons BtnSendVersion;

ImageButtons BtnSendCfgKSpeed1;
ImageButtons BtnSendCfgKSpeed2;
ImageButtons BtnSendCfgKAngle;
ImageButtons BtnSendCfgKDist;
ImageButtons BtnSendCfgWheels;
ImageButtons BtnSendCfgKvel;
ImageButtons BtnSendCfgRS232;
ImageButtons BtnSendCfgSave;
ImageButtons BtnSendCfgLoad;
ImageButtons BtnDebugOff;
ImageButtons BtnDebugOn;
ImageButtons BtnStopOff;
ImageButtons BtnStopOn;
ImageButtons BtnSendError;
ImageButtons BtnStartSeq;

ImageButtons BtnSendMainGrid;
ImageButtons BtnSendMainSet;
ImageButtons BtnSendDetailGrid;
ImageButtons BtnSendDetailSet;
ImageButtons BtnSendCycle;

// PrintWriter MeanValues;
// PrintWriter DetailValues;

// other images
PImage bg;
PImage bgConfig;
PImage bgDetails;
PImage bgSequencer;
PImage Grid;
PImage BlankGrid;
PImage LedRedOn;
PImage LedRedOff;
PImage LedGreenOn;
PImage LedGreenOff;
PImage LedYellowOn;
PImage LedYellowOff;
PImage Xscale;
PImage Yscale;

// gauges
float KnobAngle = -PI/2;
float KnobAngle1 = -PI/2;
int DesSpeed = 0;
int MesSpeed = 0;
float Current = 0;
float CurrentR = 0;
float CurrentL = 0;
float DesAngle = 0;
float DesAnglePrev = 0;
float MesAngle = 0;

int PanelIndx = 1;
boolean ReleasedFlag = false;

int Cycle = 100;
int CyclePeriod;

int RelX = 432;
int RelY = 397;
int RelX0 = 57;
int Ysize = 750;
int Xsize = 750;
int RelY0 = 21 + Ysize;

int i = 0;
float PrevX = 0;
float PrevY = 0;
float DeltaX = 0;
float DeltaY = 0;
float Xpos = 0;
float Ypos = 0;
float Distance = 0;
float DeltaDist = 0;
float PrevXtmp = 0;      // just for simulation
float PrevYtmp = 0;      // just for simulation

int DesDist = 0;
int DesCoordX = 0;
int DesCoordY = 0;

int TxPeriod = 500;
int TxTimer;
boolean BlinkFlag;
boolean TxFlag = false;

Serial RS232Port;
int RS232ComPort = 99;
int RS232Bps;

String[] StrCfg = new String[38];  // config string
String[] SerialList = new String[0];  // declare an empty string for serial ports list 
byte[] TxBuff = new byte[32];  // Transmission buffer
int TxHeadLen = 4;             // TX header lenght
int[] TxIntValue = new int[8]; // int value buffer

int IdleCount = 0;
int IdleTime = 0;
int IdleTimeP = 0;

float CharTime = (0.2f); // time period in ms for a char sent on RS232

int[] RxBuff = new int[32];

int Err = 0;
int HeadLen = 4;    // RX-TX header length

char Ver[] = new char[32];

PFont CharFont;
PFont FixFont;

boolean DebugFlag = false;
int ErrorCode = 0;
int IdlePerc;

int MaxSpeedData = 750;
int Max = 750;
int MaxYvalue = 500;
int Yoffset = Ysize/4;
int[] Speed1 = new int[MaxSpeedData+10]; // Y axis graph data for first value
int[] Speed2 = new int[MaxSpeedData+10]; // Y axis graph data for second value
int[] Speed0 = new int[MaxSpeedData+10]; // Y axis graph data for mean value
int SpeedDataPtr = 1;                 // array index pointer
int SpeedDataStep = 1;                // X axis step
float Xk;                             // X costant multiplier to draw graph
float Yk;                             // Y costant multiplier to draw graph
float Xkofst;                         // X offset to draw graph
float Ykofst;                         // Y offset to draw graph

int MainGridMinX;
int MainGridMaxX;
int MainGridMinY;
int MainGridMaxY;
int MainGridXstep;
int MainGridYstep;
int MainGridXstepSmall;
int MainGridYstepSmall;
int MainGridFlag;
int MainGridSet;

int DetailGridMinX;
int DetailGridMaxX;
int DetailGridMinY;
int DetailGridMaxY;
int DetailGridXstep;
int DetailGridYstep;
int DetailGridXstepSmall;
int DetailGridYstepSmall;
int DetailGridFlag;
int DetailGridSet;
float Step;
  
// it will be set false after RS232 configuration to start real communication
boolean PreInitRS232Flag = true;  
boolean StopFlag = true;

/* in order to allow usage of the applet in a browser as a demo simulation,
   some functions that access to HW resources must me disabled, otherwise a
   security violation error occurs.
*/
boolean SimulationDrawFlag = false;
boolean SimulationCfgFlag = false;
boolean SimulationRS232Flag = false;

/*/////////////////////////////////////////////////////////////////////////////*/

public void setup()
{
  int ii = 0;
  size(1295, 815);
  smooth();

  CharFont = loadFont("HelveticaNeue-Bold-48.vlw"); 
  fill(255,255,255);
  textFont(CharFont, 16); 
  textAlign(CENTER);
  
  FixFont = loadFont("Courier-Bold-48.vlw"); 
  
  bg = loadImage("Panel.gif");
  bgConfig = loadImage("ConfigPanel.gif");
  bgDetails = loadImage("DetailsPanel.gif");
  bgSequencer = loadImage("SequencerPanel.gif");
  background(bg);
  InputFieldsDefinition();
  LoadCfg();
//  MeanValues = createWriter("Mean.txt"); 
//  MeanValues.print("*****************"+day()+"-"+month()+"-"+year()+"*****************"); 
//  MeanValues.println();
//  MeanValues.flush();
  
//  DetailValues = createWriter("Detail.txt"); 
//  DetailValues.print("*****************"+day()+"-"+month()+"-"+year()+"*****************"); 
//  DetailValues.println();
//  DetailValues.flush();
  
  DefineMainGrid();
 //  BlankGrid = get(57,21,751,751);
  LedRedOn = loadImage("LedRedOn.gif");
  LedRedOff = loadImage("LedRedOff.gif");
  LedGreenOn = loadImage("LedGreenOn.gif");
  LedGreenOff = loadImage("LedGreenOff.gif");
  LedYellowOn = loadImage("LedYellowOn.gif");
  LedYellowOff = loadImage("LedYellowOff.gif");
  
  DefineButtons();
  
  strokeWeight(3.0f);
  stroke(255,0,0);
  
  if (! SimulationRS232Flag)
  {
    i=0;
    while(i< Serial.list().length)
    {
      SerialList = (append(SerialList, Serial.list()[i]));
      i++;
    }
  }
  else
  {
    i=1;
    while(i < 5)
    {
      SerialList = (append(SerialList, "COM"+i));
      i++;
    }
    SerialList = (append(SerialList, "All COM ports are simulated"));
  }
}

// main loop --------------------------------------------------------------------
public void draw()
{ 
  switch (PanelIndx)
  {
    case 1:
      MainPanel();
    break;
    
    case 2:
      ConfigPanel();
    break;
    
    case 3:
      DetailsPanel();
    break;
    
    case 4:
      SequencerPanel();
    break;
    
    default:
      MainPanel(); 
    break;
  }

  image(LedYellowOff,1169,700);
  IdleCount++;     // count idle period in ms
  if(IdleCount > 100)
  {
    IdleCount = 0;
    IdleTimeP = millis()-IdleTime;
    IdleTime=millis();
  }
  textAlign(LEFT);
  text(IdleTimeP/100, 1200, 760);
  textAlign(CENTER);
  text(Err, 1240, 760);
  text(IdlePerc,1177,760);
  
  if ((millis()-Cycle) > CyclePeriod)  // slow loop start------------------------
  {
    Cycle = millis();
    if (SimulationDrawFlag)          // simulation
    {
      SimulationDrawing();
    }
    else
    {
        switch (PanelIndx)
        {
          case 1:  // main panel displays on graph and gaugesthe mean values and the position
            if (!PreInitRS232Flag && !StopFlag)
            {
              TxData(0, 'A', 0, 3);  // ask for all parameters
              Delay(3);              // wait for data to be received
              if (RxData('A',11))
              {// two bytes -> i int
                MesSpeed = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
                Current = (float)((RxBuff[HeadLen+2] << 8) + (RxBuff[HeadLen+3]));
                Xpos = Int16toint32((RxBuff[HeadLen+4] << 8) + (RxBuff[HeadLen+5]));
                Ypos = Int16toint32((RxBuff[HeadLen+6] << 8) + (RxBuff[HeadLen+7]));
                MesAngle = Int16toint32((RxBuff[HeadLen+8] << 8) + (RxBuff[HeadLen+9]));
                IdlePerc = RxBuff[HeadLen+10];
 //               MeanValues.print(hour()+":"+minute()+":"+second()+"    "+MesSpeed+" "+Current+" "+Xpos+" "+Ypos+" "+MesAngle+" "+IdlePerc); 
 //               MeanValues.println();
                if (SimulationDrawFlag)          // simulation
                {
                  Current = abs(DesSpeed*2);                          // just for simulation
                  MesSpeed = DesSpeed;                                // just for simulation 
                  MesAngle = KnobAngle;                               // just for simulation     
                }   

              }
            }
            Graph(Xpos,Ypos);
          break;
    
          case 2:

          break;
    
          case 3:  // details panel displays on graph and gauges detailed valued
            if (!PreInitRS232Flag && !StopFlag)
            {
              TxData(0, 'a', 0, 3);  // ask for all parameters
              Delay(3);              // wait for data to be received
              if (RxData('a',12))
              {// two bytes -> i int
                Speed1[SpeedDataPtr] = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
                Speed2[SpeedDataPtr] = Int16toint32(((RxBuff[HeadLen+2] << 8) + (RxBuff[HeadLen+3])));
//                println(RxBuff[HeadLen]+" "+RxBuff[HeadLen+1]+" "+RxBuff[HeadLen+2]+" "+RxBuff[HeadLen+3]);
               
                Speed1[SpeedDataPtr] = (int)(Speed1[SpeedDataPtr] * Yk);
                Speed2[SpeedDataPtr] = (int)(Speed2[SpeedDataPtr] * Yk);
 //               Speed0[SpeedDataPtr] = (Speed1[SpeedDataPtr] + Speed2[SpeedDataPtr])/2;
                CurrentR = (float)((RxBuff[HeadLen+4] << 8) + (RxBuff[HeadLen+5]));     
                CurrentL = (float)((RxBuff[HeadLen+6] << 8) + (RxBuff[HeadLen+7])); 
 //               DetailValues.print(hour()+":"+minute()+":"+second()+"    "+Speed1[SpeedDataPtr]+" "+Speed2[SpeedDataPtr]+" "+CurrentR+" "+CurrentL); 
//                DetailValues.println();
              }
            }
            if (!StopFlag)  SpeedDataPtr+=SpeedDataStep;
          break;
          
          case 4:

          break;
    
          default:
            Graph(Xpos,Ypos);
          break;
        }
    }
    
    if (DesAnglePrev != DesAngle)
    {
      DesAnglePrev = DesAngle;
      TxIntValue[0] = (int)(DesAngle);
      TxData(0, 'O', 1, 1);
    }
    
    if (BlinkFlag)
    {
      BlinkFlag = false;
    }
    else 
    {
      BlinkFlag = true;
    }
  }                                    // slow loop end--------------------------
  
  LedBlink();
}
/*/////////////////////////////////////////////////////////////////////////////*/

/*-----------------------------------------------------------------------------*/
public boolean RxData(char Cmd,int Len)
{
  int ChkSum = 0;

  if (! PreInitRS232Flag)  // RS232 initialized
  {
        if (RS232Port.available() <= 0)
        {
          RS232Port.clear();
          textAlign(LEFT);
          text("RX error:",1040,710);
          text("TMO - No RX",1040,725);;
          textAlign(CENTER);
          Err++;
          return false;
        }
        else
        {
          for (i=0; i < Len+HeadLen+1; i++)  // loop for all data expected and only for that
          {
            RxBuff[i] = (RS232Port.read());
          }
        }
      
      if (RxBuff[0] != '@')
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("No Header",1040,725);
        text("Expected: @",1040,740);
        text("Found: " + (char)(RxBuff[0]),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      else if (RxBuff[2] != Cmd)
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("Wrong CMD",1040,725);
        text("Expected: "+Cmd,1040,740);
        text("Found: " + (char)(RxBuff[2]),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      else if (RxBuff[3] != (Len+1))
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("Wrong LEN",1040,725);
        text("Expected: "+Len,1040,740);
        text("Found: " + (RxBuff[3]-1),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      
      for (i=0; i < Len+HeadLen; i++)  //  ChkSum excluded
      {
        ChkSum += (char)(RxBuff[i]);
      }
      ChkSum = ChkSum % 256;
      if (RxBuff[i] != ChkSum)
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("ChkSum err",1040,725);
        text("Expected: "+RxBuff[i],1040,740);
        text("Found: " + ChkSum,1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      image(LedYellowOn,1169,700);
      return true;
  }
  return false;
}
    
/*-----------------------------------------------------------------------------*/
public void Delay(int Bytes)
{
   /* wait for data to be received for a time (in ms) proportional to 
      num of bytes: data bytes + TX overhead + RX overhead (Bytes+5+5)
   */
   Bytes += 10;
   int Del= (int)((CharTime * Bytes) + 0.5f);
   int StartDelay = millis();
   while ((millis()-StartDelay) < Del);
}

/*-----------------------------------------------------------------------------*/
public void LedBlink()
{
  if (BlinkFlag)  // blink green (cycle) led
  {
   image(LedGreenOn,1200,700);
  }
  else
  {
   image(LedGreenOff,1200,700);
  }
    
  if (TxFlag)  // blink red (TX) led
  {
    image(LedRedOn,1230,700);
  }
  else
  {
    image(LedRedOff,1230,700);
    TxTimer = millis();
  }
  if ((millis() - TxTimer) >= TxPeriod)
  {
    TxTimer = millis();
    TxFlag = false;
  }
}

/*-----------------------------------------------------------------------------*/
public void Graph(float Xcoord, float Ycoord)
{
    /* following statements are needed to translate the reference system from
    0(top-left), 750(bottom right) to  bottom-left, top-right scale values
    */
    pushMatrix();
    translate(RelX,RelY);
    rotate(-HALF_PI);
    strokeWeight(3);
    stroke(255,0,0);
    Xcoord = Xcoord / 10000 * 750;
    Ycoord = Ycoord / 10000 * 750;
    // rotating system switches X with Y
    line(Ycoord, Xcoord, PrevY, PrevX);
    PrevX = Xcoord;
    PrevY = Ycoord;
    popMatrix();
}

/*-----------------------------------------------------------------------------*/  
public int RangeCheckInt(String Data, int Min, int Max)
{
    int IntNum = 0;
    if (Data.length() != 0)
    {
      IntNum = Integer.parseInt(Data);
      if (IntNum < Min) IntNum = Min;
      if (IntNum > Max) IntNum = Max;
    }
    return IntNum;
}


/*-----------------------------------------------------------------------------*/  
public float RangeCheckFloat(String Data, float Min, float Max)
{
    float FloatNum = 0;
    if (Data.length() != 0)
    {
      FloatNum = Float.parseFloat(Data);
      if (FloatNum < Min) FloatNum = Min;
      if (FloatNum > Max) FloatNum = Max;
      TxFlag = true;
    }
    return FloatNum;
}

/*-----------------------------------------------------------------------------*/  
public void TxData(int Id, int Cmd, int ValueLen, int IntFlag)
{
/* Transmit a string toward dsNavCon board
   for a detailed description of protocol, see descrEng.txt in dsPID33 folder
*/
  int TxBuffCount;
  int ChkSum = 0;
  int CmdLen = 0;
  
  if (PreInitRS232Flag)  // RS232 not ready
  {
    return;
  }
  
  if (IntFlag == 0)  // byte value
  {
    CmdLen = ValueLen;  
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*2)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  if (IntFlag == 1)  // integer value
  {
    CmdLen = ValueLen*2;          // 1 int value = 2 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*2)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*2)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  if (IntFlag == 2) // long value
  {
    CmdLen = ValueLen*4;        // 1 long value = 4 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*4)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 24);
      TxBuff[(TxBuffCount*4)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount] >> 16);
      TxBuff[(TxBuffCount*4)+TxHeadLen+2] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*4)+TxHeadLen+3] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  TxBuff[0] = (byte)('@');
  TxBuff[1] = (byte)(Id);
  TxBuff[2] = (byte)(Cmd);
  TxBuff[3] = (byte)(CmdLen+1);  // included CheckSum

  for (i=0;i<(TxHeadLen+CmdLen);i++) 
  {
   ChkSum += TxBuff[i];
  }
  TxBuff[TxHeadLen+CmdLen] = (byte)(ChkSum);
  
  for (i=0;i<(TxHeadLen+CmdLen+1);i++) 
  {
    RS232Port.write(TxBuff[i]);
//    println(TxBuff[i]);
   }
      
  if (IntFlag != 3) TxFlag = true; // avoid to blink TX led for continuos send
}

/*-----------------------------------------------------------------------------*/
public void LoadCfg()  // Load data from config.txt file
{
  if (! SimulationCfgFlag)
  {
    if (loadStrings("config.txt") != null)
    {
      StrCfg = loadStrings("config.txt");
    }
    else 
    {
      CfgDefault();
      saveStrings("config.txt",StrCfg);
    }
  }
  else
  {
    CfgDefault();
  }
  
  FillTextFields();
}

/*-----------------------------------------------------------------------------*/
public void CfgDefault()
{//if file config.txt is not present a new one is created with defaults
      StrCfg[0] = "6000";
      StrCfg[1] = "2000";
      StrCfg[2] = "200";
      StrCfg[3] = "6000";
      StrCfg[4] = "2000";
      StrCfg[5] = "200";
      StrCfg[6] = "9999";
      StrCfg[7] = "0";
      StrCfg[8] = "1";
      StrCfg[9] = "9999";
      StrCfg[10] = "0";
      StrCfg[11] = "1";
      StrCfg[12] = "1852222";
      StrCfg[13] = "5061455";
      StrCfg[14] = "5061455";
      StrCfg[15] = "13145171";
      StrCfg[16] = "13145171";
      StrCfg[17] = "57600";
      StrCfg[18] = "0";
  
      StrCfg[19] =  "-5000";
      StrCfg[20] =  "5000";
      StrCfg[21] =  "-5000";
      StrCfg[22] =  "5000";
      StrCfg[23] =  "10";
      StrCfg[24] =  "10";
      StrCfg[25] =  "50";
      StrCfg[26] =  "50";
      StrCfg[27] =  "0";

      StrCfg[28] =  "-150";
      StrCfg[29] =  "0";
      StrCfg[30] =  "-500";
      StrCfg[31] =  "500";
      StrCfg[32] =  "15";
      StrCfg[33] =  "20";
      StrCfg[34] =  "100";
      StrCfg[35] =  "75";
      StrCfg[36] =  "3";
      StrCfg[37] =  "200";
    
}

/*-----------------------------------------------------------------------------*/
public void FillTextFields()
{
       textFont(CharFont, 10); 
       InputSpeed1Kp.setValue(StrCfg[0]);
       InputSpeed1Ki.setValue(StrCfg[1]);
       InputSpeed1Kd.setValue(StrCfg[2]);
       InputSpeed2Kp.setValue(StrCfg[3]);
       InputSpeed2Ki.setValue(StrCfg[4]);
       InputSpeed2Kd.setValue(StrCfg[5]);
       InputAngleKp.setValue(StrCfg[6]);
       InputAngleKi.setValue(StrCfg[7]);
       InputAngleKd.setValue(StrCfg[8]);
       InputDistKp.setValue(StrCfg[9]);
       InputDistKi.setValue(StrCfg[10]);
       InputDistKd.setValue(StrCfg[11]);
       InputAxle.setValue(StrCfg[12]);
       InputWheel1.setValue(StrCfg[13]);
       InputWheel2.setValue(StrCfg[14]);
       InputCpr.setValue(StrCfg[15]);
       InputGear.setValue(StrCfg[16]);
       InputRS232bps.setValue(StrCfg[17]);
       InputRS232Com.setValue(StrCfg[18]);
       
       InputMGXmin.setValue(StrCfg[19]);
       InputMGXmax.setValue(StrCfg[20]);
       InputMGYmin.setValue(StrCfg[21]);
       InputMGYmax.setValue(StrCfg[22]);
       InputMGXstep.setValue(StrCfg[23]);
       InputMGYstep.setValue(StrCfg[24]);
       InputMGXSteps.setValue(StrCfg[25]);
       InputMGYSteps.setValue(StrCfg[26]);
       InputMGset.setValue("0");
       
       InputDGXmin.setValue(StrCfg[28]);
       InputDGXmax.setValue(StrCfg[29]);
       InputDGYmin.setValue(StrCfg[30]);
       InputDGYmax.setValue(StrCfg[31]);
       InputDGXstep.setValue(StrCfg[32]);
       InputDGYstep.setValue(StrCfg[33]);
       InputDGXSteps.setValue(StrCfg[34]);
       InputDGYSteps.setValue(StrCfg[35]);
       InputDGset.setValue("0");
       InputCycle.setValue(StrCfg[37]);
       textFont(CharFont, 15); 
      
      MainGridMinX = Integer.parseInt(StrCfg[19]);
      MainGridMaxX = Integer.parseInt(StrCfg[20]);
      MainGridMinY = Integer.parseInt(StrCfg[21]);
      MainGridMaxY = Integer.parseInt(StrCfg[22]);
      MainGridXstep = Integer.parseInt(StrCfg[23]);
      MainGridYstep = Integer.parseInt(StrCfg[24]);
      MainGridXstepSmall = Integer.parseInt(StrCfg[25]);
      MainGridYstepSmall = Integer.parseInt(StrCfg[26]);
      MainGridFlag = Integer.parseInt(StrCfg[27]);

      DetailGridMinX = Integer.parseInt(StrCfg[28]);
      DetailGridMaxX = Integer.parseInt(StrCfg[29]);
      DetailGridMinY = Integer.parseInt(StrCfg[30]);
      DetailGridMaxY = Integer.parseInt(StrCfg[31]);
      DetailGridXstep = Integer.parseInt(StrCfg[32]);
      DetailGridYstep = Integer.parseInt(StrCfg[33]);
      DetailGridXstepSmall = Integer.parseInt(StrCfg[34]);
      DetailGridYstepSmall = Integer.parseInt(StrCfg[35]);
      DetailGridFlag = Integer.parseInt(StrCfg[36]); 
      CyclePeriod = Integer.parseInt(StrCfg[37]);
 }
       
/*-----------------------------------------------------------------------------*/
public void SaveCfg()  // Save current data to config.txt file
{
      StrCfg[0] = InputSpeed1Kp.getValue();
      StrCfg[1] = InputSpeed1Ki.getValue();
      StrCfg[2] = InputSpeed1Kd.getValue();
      StrCfg[3] = InputSpeed2Kp.getValue();
      StrCfg[4] = InputSpeed2Ki.getValue();
      StrCfg[5] = InputSpeed2Kd.getValue();
      StrCfg[6] = InputAngleKp.getValue();
      StrCfg[7] = InputAngleKi.getValue();
      StrCfg[8] = InputAngleKd.getValue();
      StrCfg[9] = InputDistKp.getValue();
      StrCfg[10] = InputDistKi.getValue();
      StrCfg[11] = InputDistKd.getValue();
      StrCfg[12] = InputAxle.getValue();
      StrCfg[13] = InputWheel1.getValue();
      StrCfg[14] = InputWheel2.getValue();
      StrCfg[15] = InputCpr.getValue();
      StrCfg[16] = InputGear.getValue();
      StrCfg[17] = InputRS232bps.getValue();
      StrCfg[18] = InputRS232Com.getValue();
      
      StrCfg[19] =  nf(MainGridMinX,0);
      StrCfg[20] =  nf(MainGridMaxX,0);
      StrCfg[21] =  nf(MainGridMinY,0);
      StrCfg[22] =  nf(MainGridMaxY,0);
      StrCfg[23] =  nf(MainGridXstep,0);
      StrCfg[24] =  nf(MainGridYstep,0);
      StrCfg[25] =  nf(MainGridXstepSmall,0);
      StrCfg[26] =  nf(MainGridYstepSmall,0);
      StrCfg[27] =  nf(MainGridFlag,0);

      StrCfg[28] =  nf(DetailGridMinX,0);
      StrCfg[29] =  nf(DetailGridMaxX,0);
      StrCfg[30] =  nf(DetailGridMinY,0);
      StrCfg[31] =  nf(DetailGridMaxY,0);
      StrCfg[32] =  nf(DetailGridXstep,0);
      StrCfg[33] =  nf(DetailGridYstep,0);
      StrCfg[34] =  nf(DetailGridXstepSmall,0);
      StrCfg[35] =  nf(DetailGridYstepSmall,0);
      StrCfg[36] =  nf(DetailGridFlag,0);
      StrCfg[37] =  nf(CyclePeriod,0);
      
      if (! SimulationCfgFlag)
      {
        saveStrings("config.txt",StrCfg);
      }
}

/*-----------------------------------------------------------------------------*/
public int Int16toint32 (int Int16)
{
// data coming from micro are in 16 bit int, needs to be converted in 32 bit int
        if (Int16 > 32768)
        {
          Int16 -= 65536;  
        }
        
        return Int16;
}

/*-----------------------------------------------------------------------------*/
public void Plot ()
{
  int ind = 1;
  int ptr;
  int IndPrev;
  int MaxInd;
  float StepTmp;
  pushMatrix();
  translate(RelX0,RelY-(Yoffset));
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(255,255,0);
  // rotating system switches X with Y
  
  if (Step >= 1)
  {
     MaxInd = (int)(MaxSpeedData/Step);
     StepTmp = Step;
  }
  else
  {
    MaxInd = MaxSpeedData;
    StepTmp = 1;
  }
  
  if (SpeedDataPtr>=MaxInd)
  {
    SpeedDataPtr=0;
  }
  
  IndPrev = (int)(StepTmp);
  for (ind=1; ind < MaxInd; ind++)
  {
    ptr=(ind+SpeedDataPtr) % MaxInd;
    if (ptr>0)
    {
      line((Speed1[ptr-1]), IndPrev, (Speed1[ptr]), ind*StepTmp+1);
      IndPrev = (int)(ind*StepTmp);
    }
  }
  popMatrix();

  pushMatrix();
  translate(RelX0,RelY+Yoffset);
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(0,0,255);
  // rotating system switches X with Y

  IndPrev = (int)(StepTmp);
  for (ind=1; ind < MaxInd; ind++)
  {
    ptr=(ind+SpeedDataPtr) % MaxInd;
    if (ptr>0)
    {
      line((Speed2[ptr-1]), IndPrev, (Speed2[ptr]), ind*StepTmp+1);
      IndPrev = (int)(ind*StepTmp);
    }
  }
  popMatrix();
  
  /*
  pushMatrix();
  translate(RelX0,RelY);
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(255,0,0);
  // rotating system switches X with Y
  
  for (ind=1; ind < MaxSpeedData; ind++)
  {
    ptr=(ind+SpeedDataPtr) % (MaxSpeedData);
    if (ptr<(MaxSpeedData-1))
    {
      line((Speed0[ptr] * Yk), ind, (Speed0[ptr+1] * Yk), ind+1);
    }

  }
  popMatrix();
 */
}

public void DefineMainGrid ()
{
   DefineGrid(MainGridMinX, MainGridMaxX, MainGridMinY, MainGridMaxY, MainGridXstep, 
               MainGridYstep, MainGridXstepSmall, MainGridYstepSmall, MainGridFlag);
}

public void DefineDetailsGrid ()
{
  int ii;
  int MaxInd;
  
  DefineGrid(DetailGridMinX, DetailGridMaxX, DetailGridMinY, DetailGridMaxY, 
               DetailGridXstep, DetailGridYstep, DetailGridXstepSmall, 
               DetailGridYstepSmall, DetailGridFlag);
               
   Yk = Yk/2;
   
/*  // When scale changes, the plot buffer is flushed
  for (ii=1; ii< MaxSpeedData; ii++)
  {
    Speed1 [ii] = 0;
  }
  
     for (ii=1; ii< MaxSpeedData; ii++)
  {
    Speed2 [ii] = 0;
  }
*/

/*  //////////////// Debug
  if (Step >= 1)
  {
     MaxInd = (int)(MaxSpeedData/Step);
  }
  else
  {
    MaxInd = MaxSpeedData;
  }

  for (ii=1; ii< (MaxInd); ii++)
  {
    Speed1 [ii] = ((int) (sin(radians(ii))*(400)))*Yoffset/MaxYvalue;
  }
  
     for (ii=1; ii< MaxInd; ii++)
  {
    Speed2 [ii] = ((int) (cos(radians(ii))*(400)))*Yoffset/MaxYvalue;
  }
  //////////////// Debug */
}

/*-----------------------------------------------------------------------------
void serialEvent(Serial p) 
{ 
    RxBuff[RxBuffCount] = (byte)(RS232Port.read());
        println(RxBuffCount+ " " +(char)(RxBuff[RxBuffCount]));
    RxBuffCount++;
}
*/
/*-----------------------------------------------------------------------------*/
public void SimulationDrawing()
{// just for simulation
    DeltaDist = (MesSpeed * CyclePeriod) / 1000; 
    Distance += DeltaDist;
    DeltaX = DeltaDist * (sin(MesAngle + HALF_PI));
    DeltaY = DeltaDist * (cos(MesAngle + HALF_PI));
    Graph(DeltaX+PrevXtmp,DeltaY+PrevYtmp);
    PrevXtmp = DeltaX+PrevXtmp;
    PrevYtmp = DeltaY+PrevYtmp;
}

public void SimulationRxAll()
{
// just for simulation      
      RxBuff[0] = '@';
      RxBuff[1] = 0;
      RxBuff[2] = 'A';
      RxBuff[3] = 11;
      RxBuff[4] = 0;
      RxBuff[5] = 0;
      RxBuff[6] = 0;
      RxBuff[7] = 0;
      RxBuff[8] = 0;
      RxBuff[9] = 0;
      RxBuff[10] = 0;
      RxBuff[11] = 0;
      RxBuff[12] = 0;
      RxBuff[13] = 0;
      RxBuff[14] = -116;
}

public void SimulationRxVer()
{
// just for simulation      
      RxBuff[0] = '@';
      RxBuff[1] = 0;
      RxBuff[2] = 'R';
      RxBuff[3] = 28;
      RxBuff[4] = 'd';
      RxBuff[5] = 's';
      RxBuff[6] = 'O';
      RxBuff[7] = 'D';
      RxBuff[8] = 'O';
      RxBuff[9] = ' ';
      RxBuff[10] ='1';
      RxBuff[11] ='.';
      RxBuff[12] ='0';
      RxBuff[13] ='.';
      RxBuff[14] ='0';
      RxBuff[15] =' ';
      RxBuff[16] ='b';
      RxBuff[17] ='y';
      RxBuff[18] =' ';
      RxBuff[19] ='G';
      RxBuff[20] ='u';
      RxBuff[21] ='i';
      RxBuff[22] ='o';
      RxBuff[23] ='t';
      RxBuff[24] ='t';
      RxBuff[25] =' ';
      RxBuff[26] ='0';
      RxBuff[27] ='2';
      RxBuff[28] ='-';
      RxBuff[29] ='0';
      RxBuff[30] ='8';
      RxBuff[31] =116;
}

/*-----------------------------------------------------------------------------*/
public void DefineButtons()
{
 // Define and create image button for Main panel *************************
  PImage b = loadImage("BtnConfigN.gif");
  PImage r = loadImage("BtnConfigO.gif");
  PImage d = loadImage("BtnConfigP.gif");
  int x = 845;
  int y = 772; 
  int w = b.width;
  int h = b.height;
  BtnConfig = new ImageButtons(x, y, w, h, b, r, d);
  
  PImage b2 = loadImage("BtnQuitN.gif");
  PImage r2 = loadImage("BtnQuitO.gif");
  PImage d2 = loadImage("BtnQuitP.gif");
  int x2 = 945;
  int y2 = 772; 
  int w2 = b.width;
  int h2 = b.height;
  BtnQuit = new ImageButtons(x2, y2, w2, h2, b2, r2, d2);
  
  PImage b4 = loadImage("BtnRunN.gif");
  PImage r4 = loadImage("BtnRunO.gif");
  PImage d4 = loadImage("BtnRunP.gif");
  int x4 = 845;
  int y4 = 772; 
  int w4 = b.width;
  int h4 = b.height;
  BtnRun = new ImageButtons(x4, y4, w4, h4, b4, r4, d4);

  PImage b3 = loadImage("BtnSendN.gif");
  PImage r3 = loadImage("BtnSendO.gif");
  PImage d3 = loadImage("BtnSendP.gif");
  int x3 = 1170;
  int y3 = 500; 
  int w3 = b.width;
  int h3 = b.height;
  BtnSendSpeed = new ImageButtons(x3, y3, w3, h3, b3, r3, d3);
  
  PImage b6 = loadImage("BtnSendN.gif");
  PImage r6 = loadImage("BtnSendO.gif");
  PImage d6 = loadImage("BtnSendP.gif");
  int x6 = 1170;
  int y6 = 550; 
  int w6 = b.width;
  int h6 = b.height;
  BtnSendDist = new ImageButtons(x6, y6, w6, h6, b6, r6, d6);

  PImage b5 = loadImage("BtnSendN.gif");
  PImage r5 = loadImage("BtnSendO.gif");
  PImage d5 = loadImage("BtnSendP.gif");
  int x5 = 1170;
  int y5 = 600; 
  int w5 = b.width;
  int h5 = b.height;
  BtnSendXY = new ImageButtons(x5, y5, w5, h5, b5, r5, d5);
 
  PImage b7 = loadImage("BtnVersionN.gif");
  PImage r7 = loadImage("BtnVersionO.gif");
  PImage d7 = loadImage("BtnVersionP.gif");
  int x7 = 1170;
  int y7 = 650; 
  int w7 = b.width;
  int h7 = b.height;
  BtnSendVersion = new ImageButtons(x7, y7, w7, h7, b7, r7, d7);

  PImage b8 = loadImage("BtnHaltN.gif");
  PImage r8 = loadImage("BtnHaltO.gif");
  PImage d8 = loadImage("BtnHaltP.gif");
  int x8 = 845;
  int y8 = 685; 
  int w8 = b.width;
  int h8 = b.height;
  BtnSendHalt = new ImageButtons(x8, y8, w8, h8, b8, r8, d8);

  PImage b9 = loadImage("BtnResetN.gif");
  PImage r9 = loadImage("BtnResetO.gif");
  PImage d9 = loadImage("BtnResetP.gif");
  int x9 = 945;
  int y9 = 685; 
  int w9 = b.width;
  int h9 = b.height;
  BtnSendReset = new ImageButtons(x9, y9, w9, h9, b9, r9, d9);
  
  PImage b32 = loadImage("BtnStartN.gif");
  PImage r32 = loadImage("BtnStartO.gif");
  PImage d32 = loadImage("BtnStartP.gif");
  int x32 = 845;
  int y32 = 500; 
  int w32 = b.width;
  int h32 = b.height;
  BtnStartSeq = new ImageButtons(x32, y32, w32, h32, b32, r32, d32);
  
  
  
  // Define and create image button for Config panel *************************
  PImage b24 = loadImage("BtnDetN.gif");
  PImage r24 = loadImage("BtnDetO.gif");
  PImage d24 = loadImage("BtnDetP.gif");
  int x24 = 945;
  int y24 = 772; 
  int w24 = b.width;
  int h24 = b.height;
  BtnDet = new ImageButtons(x24, y24, w24, h24, b24, r24, d24);

  PImage b10 = loadImage("BtnSendN.gif");
  PImage r10 = loadImage("BtnSendO.gif");
  PImage d10 = loadImage("BtnSendP.gif");
  int x10 = 1190;
  int y10 = 59; 
  int w10 = b.width;
  int h10 = b.height;
  BtnSendCfgKSpeed1 = new ImageButtons(x10, y10, w10, h10, b10, r10, d10);
  
  PImage b11 = loadImage("BtnSendN.gif");
  PImage r11 = loadImage("BtnSendO.gif");
  PImage d11 = loadImage("BtnSendP.gif");
  int x11 = 1190;
  int y11 = 69; 
  int w11 = b.width;
  int h11 = b.height;
  BtnSendCfgKSpeed2 = new ImageButtons(x11, y11, w11, h11, b11, r11, d11);
  
  PImage b12 = loadImage("BtnSendN.gif");
  PImage r12 = loadImage("BtnSendO.gif");
  PImage d12 = loadImage("BtnSendP.gif");
  int x12 = 1190;
  int y12 = 172; 
  int w12 = b.width;
  int h12 = b.height;
  BtnSendCfgKAngle = new ImageButtons(x12, y12, w12, h12, b12, r12, d12);
  
  PImage b13 = loadImage("BtnSendN.gif");
  PImage r13 = loadImage("BtnSendO.gif");
  PImage d13 = loadImage("BtnSendP.gif");
  int x13 = 1190;
  int y13 = 229; 
  int w13 = b.width;
  int h13 = b.height;
  BtnSendCfgKDist = new ImageButtons(x13, y13, w13, h13, b13, r13, d13);
  
  PImage b14 = loadImage("BtnSendN.gif");
  PImage r14 = loadImage("BtnSendO.gif");
  PImage d14 = loadImage("BtnSendP.gif");
  int x14 = 1190;
  int y14 = 285; 
  int w14 = b.width;
  int h14 = b.height;
  BtnSendCfgWheels = new ImageButtons(x14, y14, w14, h14, b14, r14, d14);
  
  PImage b18 = loadImage("BtnSendN.gif");
  PImage r18 = loadImage("BtnSendO.gif");
  PImage d18 = loadImage("BtnSendP.gif");
  int x18 = 1190;
  int y18 = 340; 
  int w18 = b.width;
  int h18 = b.height;
  BtnSendCfgKvel = new ImageButtons(x18, y18, w18, h18, b18, r18, d18);
  
  PImage b15 = loadImage("BtnSendN.gif");
  PImage r15 = loadImage("BtnSendO.gif");
  PImage d15 = loadImage("BtnSendP.gif");
  int x15 = 1190;
  int y15 = 400; 
  int w15 = b.width;
  int h15 = b.height;
  BtnSendCfgRS232 = new ImageButtons(x15, y15, w15, h15, b15, r15, d15);
  
  PImage b23 = loadImage("BtnErrorN.gif");
  PImage r23 = loadImage("BtnErrorO.gif");
  PImage d23 = loadImage("BtnErrorP.gif");
  int x23 = 1190;
  int y23 = 456; 
  int w23 = b.width;
  int h23 = b.height;
  BtnSendError = new ImageButtons(x23, y23, w23, h23, b23, r23, d23);
  
  PImage b19 = loadImage("BtnDebugOffN.gif");
  PImage r19 = loadImage("BtnDebugOffO.gif");
  PImage d19 = loadImage("BtnDebugOffP.gif");
  int x19 = 845;
  int y19 = 738; 
  int w19 = b.width;
  int h19 = b.height;
  BtnDebugOff = new ImageButtons(x19, y19, w19, h19, b19, r19, d19);
  
  PImage b20 = loadImage("BtnDebugOnN.gif");
  PImage r20 = loadImage("BtnDebugOnO.gif");
  PImage d20 = loadImage("BtnDebugOnP.gif");
  int x20 = 845;
  int y20 = 738; 
  int w20 = b.width;
  int h20 = b.height;
  BtnDebugOn = new ImageButtons(x20, y20, w20, h20, b20, r20, d20);
  
  PImage b21 = loadImage("BtnStopOffN.gif");
  PImage r21 = loadImage("BtnStopOffO.gif");
  PImage d21 = loadImage("BtnStopOffP.gif");
  int x21 = 945;
  int y21 = 738; 
  int w21 = b.width;
  int h21 = b.height;
  BtnStopOff = new ImageButtons(x21, y21, w21, h21, b21, r21, d21);
  
  PImage b22 = loadImage("BtnStopOnN.gif");
  PImage r22 = loadImage("BtnStopOnO.gif");
  PImage d22 = loadImage("BtnStopOnP.gif");
  int x22 = 945;
  int y22 = 738; 
  int w22 = b.width;
  int h22 = b.height;
  BtnStopOn = new ImageButtons(x22, y22, w22, h22, b22, r22, d22);
  
  PImage b16 = loadImage("BtnLoadN.gif");
  PImage r16 = loadImage("BtnLoadO.gif");
  PImage d16 = loadImage("BtnLoadP.gif");
  int x16 = 845;
  int y16 = 738; 
  int w16 = b.width;
  int h16 = b.height;
  BtnSendCfgLoad = new ImageButtons(x16, y16, w16, h16, b16, r16, d16);

  PImage b17 = loadImage("BtnSaveN.gif");
  PImage r17 = loadImage("BtnSaveO.gif");
  PImage d17 = loadImage("BtnSaveP.gif");
  int x17 = 945;
  int y17 = 738; 
  int w17 = b.width;
  int h17 = b.height;
  BtnSendCfgSave = new ImageButtons(x17, y17, w17, h17, b17, r17, d17);
  
  PImage b25 = loadImage("BtnSendN.gif");
  PImage r25 = loadImage("BtnSendO.gif");
  PImage d25 = loadImage("BtnSendP.gif");
  int x25 = 35;
  int y25 = 59; 
  int w25 = b.width;
  int h25 = b.height;
  BtnSendMainGrid = new ImageButtons(x25, y25, w25, h25, b25, r25, d25);
 
  PImage b26 = loadImage("BtnSendN.gif");
  PImage r26 = loadImage("BtnSendO.gif");
  PImage d26 = loadImage("BtnSendP.gif");
  int x26 = 35;
  int y26 = 172; 
  int w26 = b.width;
  int h26 = b.height;
  BtnSendMainSet = new ImageButtons(x26, y26, w26, h26, b26, r26, d26);
  
  PImage b27 = loadImage("BtnSendN.gif");
  PImage r27 = loadImage("BtnSendO.gif");
  PImage d27 = loadImage("BtnSendP.gif");
  int x27 = 35;
  int y27 = 229; 
  int w27 = b.width;
  int h27 = b.height;
  BtnSendDetailGrid = new ImageButtons(x27, y27, w27, h27, b27, r27, d27);
 
  PImage b28 = loadImage("BtnSendN.gif");
  PImage r28 = loadImage("BtnSendO.gif");
  PImage d28 = loadImage("BtnSendP.gif");
  int x28 = 35;
  int y28 = 342; 
  int w28 = b.width;
  int h28 = b.height;
  BtnSendDetailSet = new ImageButtons(x28, y28, w28, h28, b28, r28, d28);
  
  PImage b29 = loadImage("BtnSendN.gif");
  PImage r29 = loadImage("BtnSendO.gif");
  PImage d29 = loadImage("BtnSendP.gif");
  int x29 = 35;
  int y29 = 399; 
  int w29 = b.width;
  int h29 = b.height;
  BtnSendCycle = new ImageButtons(x29, y29, w29, h29, b29, r29, d29);
  
  
  // Define and create image button for Sequencer panel *************************  
  PImage b30 = loadImage("BtnSeqN.gif");
  PImage r30 = loadImage("BtnSeqO.gif");
  PImage d30 = loadImage("BtnSeqP.gif");
  int x30 = 945;
  int y30 = 772; 
  int w30 = b.width;
  int h30 = b.height;
  BtnSeqL = new ImageButtons(x30, y30, w30, h30, b30, r30, d30);
   
  PImage b31 = loadImage("BtnSeqN.gif");
  PImage r31 = loadImage("BtnSeqO.gif");
  PImage d31 = loadImage("BtnSeqP.gif");
  int x31 = 845;
  int y31 = 772; 
  int w31 = b.width;
  int h31 = b.height;
  BtnSeqR = new ImageButtons(x31, y31, w31, h31, b31, r31, d31);

}

/*-----------------------------------------------------------------------------*/
public void InputFieldsDefinition()
{
  // Define and create input fields for Main panel  *************************
  GuiRun = new GUIController(this);
  InputSpeed = new IFTextField("", 1043, 503, 67);
  InputSpeed.addActionListener(this);
  GuiRun.add(InputSpeed);
  
  InputDist = new IFTextField("", 1043, 553, 67);
  InputDist.addActionListener(this);
  GuiRun.add(InputDist);
  
  InputCoordY = new IFTextField("", 1043, 603, 67);
  InputCoordY.addActionListener(this);
  GuiRun.add(InputCoordY);

  InputCoordX = new IFTextField("", 923, 603, 67);
  InputCoordX.addActionListener(this);
  GuiRun.add(InputCoordX);
  
  
  // Define and create input fields for Config panel  *************************
  GuiConfig = new GUIController(this);
  InputSpeed1Kp = new IFTextField("", 856, 63, 73);
  InputSpeed1Kp.addActionListener(this);
  
  InputSpeed1Ki = new IFTextField("", 969, 63, 73);
  InputSpeed1Ki.addActionListener(this);

  InputSpeed1Kd = new IFTextField("", 1083, 63, 73);
  InputSpeed1Kd.addActionListener(this);

  InputSpeed2Kp = new IFTextField("", 856, 119, 73);
  InputSpeed2Kp.addActionListener(this);
  
  InputSpeed2Ki = new IFTextField("", 969, 119, 73);
  InputSpeed2Ki.addActionListener(this);

  InputSpeed2Kd = new IFTextField("", 1083, 119, 73);
  InputSpeed2Kd.addActionListener(this);

  InputAngleKp = new IFTextField("", 856, 176, 73);
  InputAngleKp.addActionListener(this);
  
  InputAngleKi = new IFTextField("", 969, 176, 73);
  InputAngleKi.addActionListener(this);

  InputAngleKd = new IFTextField("", 1083, 176, 73);
  InputAngleKd.addActionListener(this);

  InputDistKp = new IFTextField("", 856, 232, 73);
  InputDistKp.addActionListener(this);
  
  InputDistKi = new IFTextField("", 969, 232, 73);
  InputDistKi.addActionListener(this);

  InputDistKd = new IFTextField("", 1083, 232, 73);
  InputDistKd.addActionListener(this);

  InputAxle = new IFTextField("", 856, 289, 73);
  InputAxle.addActionListener(this);

  InputWheel1 = new IFTextField("", 969, 289, 73);
  InputWheel1.addActionListener(this);

  InputWheel2 = new IFTextField("", 1083, 289, 73);
  InputWheel2.addActionListener(this);

  InputCpr = new IFTextField("", 969, 346, 73);
  InputCpr.addActionListener(this);

  InputGear = new IFTextField("", 1083, 346, 73);
  InputGear.addActionListener(this);
  
  InputRS232bps = new IFTextField("", 969, 403, 73);
  InputRS232bps.addActionListener(this);

  InputRS232Com = new IFTextField("", 1083, 403, 73);
  InputRS232Com.addActionListener(this);
  
  
  GuiConfig2 = new GUIController(this);
  InputMGXmin = new IFTextField("", 148, 63, 73);
  InputMGXmin.addActionListener(this);
  
  InputMGXmax = new IFTextField("", 261, 63, 73);
  InputMGXmax.addActionListener(this);
  
  InputMGYmin = new IFTextField("", 375, 63, 73);
  InputMGYmin.addActionListener(this);
  
  InputMGYmax = new IFTextField("", 488, 63, 73);
  InputMGYmax.addActionListener(this);


  
  InputMGXstep = new IFTextField("", 148, 119, 73);
  InputMGXstep.addActionListener(this);
  
  InputMGYstep = new IFTextField("", 261, 119, 73);
  InputMGYstep.addActionListener(this);
  
  InputMGXSteps = new IFTextField("", 375, 119, 73);
  InputMGXSteps.addActionListener(this);
   
  InputMGYSteps = new IFTextField("", 488, 119, 73);
  InputMGYSteps.addActionListener(this);
  
  InputMGset = new IFTextField("", 148, 176, 73);
  InputMGset.addActionListener(this);
  
  
  InputDGXmin = new IFTextField("", 148, 232, 73);
  InputDGXmin.addActionListener(this);
  
  InputDGXmax = new IFTextField("", 261, 232, 73);
  InputDGXmin.addActionListener(this);
  
  InputDGYmin = new IFTextField("", 375, 232, 73);
  InputDGYmin.addActionListener(this);
  
  InputDGYmax = new IFTextField("", 488, 232, 73);
  InputDGYmax.addActionListener(this);

  
  InputDGXstep = new IFTextField("", 148, 289, 73);
  InputDGXstep.addActionListener(this);
  
  InputDGYstep = new IFTextField("", 261, 289, 73);
  InputDGYstep.addActionListener(this);
  
  InputDGXSteps = new IFTextField("", 375, 289, 73);
  InputDGXSteps.addActionListener(this);
   
  InputDGYSteps = new IFTextField("", 488, 289, 73);
  InputDGYSteps.addActionListener(this);
  
  InputDGset = new IFTextField("", 148, 346, 73);
  InputDGset.addActionListener(this);
  
  InputCycle = new IFTextField("", 148, 403, 73);
  InputCycle.addActionListener(this);
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsRun()   // input fields for Main panel 
{
  GuiConfig.remove(InputSpeed1Kp);
  GuiConfig.remove(InputSpeed1Ki);
  GuiConfig.remove(InputSpeed1Kd);
  
  GuiConfig.remove(InputSpeed2Kp);
  GuiConfig.remove(InputSpeed2Ki);
  GuiConfig.remove(InputSpeed2Kd);
 
  GuiConfig.remove(InputAngleKp);
  GuiConfig.remove(InputAngleKi);
  GuiConfig.remove(InputAngleKd);
  
  GuiConfig.remove(InputDistKp);
  GuiConfig.remove(InputDistKi);
  GuiConfig.remove(InputDistKd);

  GuiConfig.remove(InputAxle);
  GuiConfig.remove(InputWheel1);
  GuiConfig.remove(InputWheel2);
  
  GuiConfig.remove(InputCpr);
  GuiConfig.remove(InputGear);

  
  GuiConfig.remove(InputRS232bps);
  GuiConfig.remove(InputRS232Com);
  
  GuiConfig2.remove(InputMGXmin);
  GuiConfig2.remove(InputMGXmax);
  GuiConfig2.remove(InputMGYmin);
  GuiConfig2.remove(InputMGYmax);
  GuiConfig2.remove(InputMGXstep);
  GuiConfig2.remove(InputMGYstep);
  GuiConfig2.remove(InputMGXSteps);
  GuiConfig2.remove(InputMGYSteps);
  GuiConfig2.remove(InputMGset);
  
  GuiConfig2.remove(InputDGXmin);
  GuiConfig2.remove(InputDGXmax);
  GuiConfig2.remove(InputDGYmin);
  GuiConfig2.remove(InputDGYmax);
  GuiConfig2.remove(InputDGXstep);
  GuiConfig2.remove(InputDGYstep);
  GuiConfig2.remove(InputDGXSteps);
  GuiConfig2.remove(InputDGYSteps);
  GuiConfig2.remove(InputDGset);
  GuiConfig2.remove(InputCycle);
  
  GuiRun.add(InputSpeed);
  GuiRun.add(InputDist);
  GuiRun.add(InputCoordX);
  GuiRun.add(InputCoordY);
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsConfig()    // input fields for Config panel 
{
  GuiRun.remove(InputSpeed);
  GuiRun.remove(InputDist);
  GuiRun.remove(InputCoordX);
  GuiRun.remove(InputCoordY);
 
 
  GuiConfig.add(InputSpeed1Kp);
  GuiConfig.add(InputSpeed1Ki);
  GuiConfig.add(InputSpeed1Kd);
  
  GuiConfig.add(InputSpeed2Kp);
  GuiConfig.add(InputSpeed2Ki);
  GuiConfig.add(InputSpeed2Kd);
  
  GuiConfig.add(InputAngleKp);
  GuiConfig.add(InputAngleKi);
  GuiConfig.add(InputAngleKd);
  
  GuiConfig.add(InputDistKp);
  GuiConfig.add(InputDistKi);
  GuiConfig.add(InputDistKd);

  GuiConfig.add(InputAxle);
  GuiConfig.add(InputWheel1);
  GuiConfig.add(InputWheel2);
  
  GuiConfig.add(InputCpr);
  GuiConfig.add(InputGear);
  
  GuiConfig.add(InputRS232bps);
  GuiConfig.add(InputRS232Com);
  
  GuiConfig2.add(InputMGXmin);
  GuiConfig2.add(InputMGXmax);
  GuiConfig2.add(InputMGYmin);
  GuiConfig2.add(InputMGYmax);
  GuiConfig2.add(InputMGXstep);
  GuiConfig2.add(InputMGYstep);
  GuiConfig2.add(InputMGXSteps);
  GuiConfig2.add(InputMGYSteps);
  GuiConfig2.add(InputMGset);
  
  GuiConfig2.add(InputDGXmin);
  GuiConfig2.add(InputDGXmax);
  GuiConfig2.add(InputDGYmin);
  GuiConfig2.add(InputDGYmax);
  GuiConfig2.add(InputDGXstep);
  GuiConfig2.add(InputDGYstep);
  GuiConfig2.add(InputDGXSteps);
  GuiConfig2.add(InputDGYSteps);
  GuiConfig2.add(InputDGset);
  GuiConfig2.add(InputCycle);
}

public void InputFieldsSequencer()    // input fields for Sequencer panel 
{
  GuiRun.remove(InputSpeed);
  GuiRun.remove(InputDist);
  GuiRun.remove(InputCoordX);
  GuiRun.remove(InputCoordY);
  
  GuiConfig.remove(InputSpeed1Kp);
  GuiConfig.remove(InputSpeed1Ki);
  GuiConfig.remove(InputSpeed1Kd);
  
  GuiConfig.remove(InputSpeed2Kp);
  GuiConfig.remove(InputSpeed2Ki);
  GuiConfig.remove(InputSpeed2Kd);
 
  GuiConfig.remove(InputAngleKp);
  GuiConfig.remove(InputAngleKi);
  GuiConfig.remove(InputAngleKd);
  
  GuiConfig.remove(InputDistKp);
  GuiConfig.remove(InputDistKi);
  GuiConfig.remove(InputDistKd);

  GuiConfig.remove(InputAxle);
  GuiConfig.remove(InputWheel1);
  GuiConfig.remove(InputWheel2);
  
  GuiConfig.remove(InputCpr);
  GuiConfig.remove(InputGear);

  
  GuiConfig.remove(InputRS232bps);
  GuiConfig.remove(InputRS232Com);
  
  GuiConfig2.remove(InputMGXmin);
  GuiConfig2.remove(InputMGXmax);
  GuiConfig2.remove(InputMGYmin);
  GuiConfig2.remove(InputMGYmax);
  GuiConfig2.remove(InputMGXstep);
  GuiConfig2.remove(InputMGYstep);
  GuiConfig2.remove(InputMGXSteps);
  GuiConfig2.remove(InputMGYSteps);
  GuiConfig2.remove(InputMGset);
  
  GuiConfig2.remove(InputDGXmin);
  GuiConfig2.remove(InputDGXmax);
  GuiConfig2.remove(InputDGYmin);
  GuiConfig2.remove(InputDGYmax);
  GuiConfig2.remove(InputDGXstep);
  GuiConfig2.remove(InputDGYstep);
  GuiConfig2.remove(InputDGXSteps);
  GuiConfig2.remove(InputDGYSteps);
  GuiConfig2.remove(InputDGset);
  GuiConfig2.remove(InputCycle);

 
 /*
  GuiConfig.add(InputSpeed1Kp);
  GuiConfig.add(InputSpeed1Ki);
  GuiConfig.add(InputSpeed1Kd);
  
  GuiConfig.add(InputSpeed2Kp);
  GuiConfig.add(InputSpeed2Ki);
  GuiConfig.add(InputSpeed2Kd);
  
  GuiConfig.add(InputAngleKp);
  GuiConfig.add(InputAngleKi);
  GuiConfig.add(InputAngleKd);
  
  GuiConfig.add(InputDistKp);
  GuiConfig.add(InputDistKi);
  GuiConfig.add(InputDistKd);

  GuiConfig.add(InputAxle);
  GuiConfig.add(InputWheel1);
  GuiConfig.add(InputWheel2);
  
  GuiConfig.add(InputCpr);
  GuiConfig.add(InputGear);
  
  GuiConfig.add(InputRS232bps);
  GuiConfig.add(InputRS232Com);
  
  GuiConfig2.add(InputMGXmin);
  GuiConfig2.add(InputMGXmax);
  GuiConfig2.add(InputMGYmin);
  GuiConfig2.add(InputMGYmax);
  GuiConfig2.add(InputMGXstep);
  GuiConfig2.add(InputMGYstep);
  GuiConfig2.add(InputMGXSteps);
  GuiConfig2.add(InputMGYSteps);
  GuiConfig2.add(InputMGset);
  
  GuiConfig2.add(InputDGXmin);
  GuiConfig2.add(InputDGXmax);
  GuiConfig2.add(InputDGYmin);
  GuiConfig2.add(InputDGYmax);
  GuiConfig2.add(InputDGXstep);
  GuiConfig2.add(InputDGYstep);
  GuiConfig2.add(InputDGXSteps);
  GuiConfig2.add(InputDGYSteps);
  GuiConfig2.add(InputDGset);
  GuiConfig2.add(InputCycle);
  
 */
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsDetails()   // input fields for Details panel 
{
  GuiConfig.remove(InputSpeed1Kp);
  GuiConfig.remove(InputSpeed1Ki);
  GuiConfig.remove(InputSpeed1Kd);
  
  GuiConfig.remove(InputSpeed2Kp);
  GuiConfig.remove(InputSpeed2Ki);
  GuiConfig.remove(InputSpeed2Kd);
 
  GuiConfig.remove(InputAngleKp);
  GuiConfig.remove(InputAngleKi);
  GuiConfig.remove(InputAngleKd);
  
  GuiConfig.remove(InputDistKp);
  GuiConfig.remove(InputDistKi);
  GuiConfig.remove(InputDistKd);

  GuiConfig.remove(InputAxle);
  GuiConfig.remove(InputWheel1);
  GuiConfig.remove(InputWheel2);
  
  GuiConfig.remove(InputCpr);
  GuiConfig.remove(InputGear);

  
  GuiConfig.remove(InputRS232bps);
  GuiConfig.remove(InputRS232Com);
  
  GuiConfig2.remove(InputMGXmin);
  GuiConfig2.remove(InputMGXmax);
  GuiConfig2.remove(InputMGYmin);
  GuiConfig2.remove(InputMGYmax);
  GuiConfig2.remove(InputMGXstep);
  GuiConfig2.remove(InputMGYstep);
  GuiConfig2.remove(InputMGXSteps);
  GuiConfig2.remove(InputMGYSteps);
  GuiConfig2.remove(InputMGset);
  
  GuiConfig2.remove(InputDGXmin);
  GuiConfig2.remove(InputDGXmax);
  GuiConfig2.remove(InputDGYmin);
  GuiConfig2.remove(InputDGYmax);
  GuiConfig2.remove(InputDGXstep);
  GuiConfig2.remove(InputDGYstep);
  GuiConfig2.remove(InputDGXSteps);
  GuiConfig2.remove(InputDGYSteps);
  GuiConfig2.remove(InputDGset);
  GuiConfig2.remove(InputCycle);
  
  GuiRun.add(InputSpeed);
  GuiRun.add(InputDist);
  GuiRun.add(InputCoordX);
  GuiRun.add(InputCoordY);
}

/*-----------------------------------------------------------------------------*/  
public void actionPerformed(GUIEvent e)   // an event on input fields
{
  if (e.getMessage().equals("Completed"))
  {
    //SendSpeed();
  }
}

/*-----------------------------------------------------------------------------*/
public void mouseReleased()
{      
  ReleasedFlag = true;
}

/*-----------------------------------------------------------------------------*/
class Button 
{
  int x, y;
  int w, h;
  int basecolor, highlightcolor;
  int currentcolor;
  boolean over = false;
  boolean pressed = false;   
  boolean released = false;   
    
  public void pressed() {
    if(over && mousePressed) {
      pressed = true;
    } else {
      pressed = false;
    }    
  }
    
  public void released() {
    if(over && ReleasedFlag) {
      released = true;
      ReleasedFlag = false;
    } else {
      released = false;
    }    
  }

  public boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  public void update() 
  {
    over();
    pressed();
    released();
    if(pressed) {
      currentimage = down;
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }
  
  public void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
    } else {
      over = false;
    }
  }
  
  public void display() 
  {
    image(currentimage, x, y);
  }
}

/*-----------------------------------------------------------------------------*/
public void DefineGrid(int MinX, int MaxX, int MinY, int MaxY, int Xstep, int Ystep, 
                int XstepSmall, int YstepSmall, int Flag)
{
  int ind;
  float GridStepX = (float)(Xsize)/(float)(Xstep);
  float GridStepY = (float)(Ysize)/(float)(Ystep);
  float GridStepXsmall = (float)(Xsize)/(float)(XstepSmall);
  float GridStepYsmall = (float)(Ysize)/(float)(YstepSmall);
  int ScaleXstep = (MaxX-MinX)/Xstep;
  int ScaleYstep = (MaxY-MinY)/Ystep;
  
  Xk = (float)Xsize / (float)(MaxX-MinX);
  Yk = (float)Ysize / (float)(MaxY-MinY);
  Xkofst = (0 - MinX) * Xk;
  Ykofst = (0 - MinY) * Yk;
  float Step1tmp = (((float)(MaxSpeedData)) / ((float)(MaxX-MinX)));
  float Step2tmp = (float)(CyclePeriod)/1000;
  Step = (Step1tmp*Step2tmp);
  pushMatrix();
  translate(RelX0,RelY0);
  rotate(-HALF_PI);
  fill(0,0,0);
  stroke(200,200,200);
  strokeWeight(5);
  rect(0, 0, Xsize, Ysize);
  strokeWeight(1);
  stroke(255,255,255);
  // rotating system switches X with Y
  textAlign(CENTER);
  fill(255,255,255);
  
  rotate(HALF_PI);
  for (ind=0; ind <= Xstep; ind++)
  {
     text(MinX+(ScaleXstep*ind), (ind*GridStepX), 20);
  }
  Xscale = get(30,775,800,20);
  
  textAlign(RIGHT);
  if (Flag==3)
  { 
    for (ind=1; ind <= Ystep/2-1; ind++)
    {
       text(MinY+(ScaleYstep*2*ind), -5, -(ind*GridStepY-5));
    }
    
    for (ind=1; ind <= Ystep/2-1; ind++)
    {
       text(MinY+(ScaleYstep*2*ind), -5, -((ind+Ystep/2)*GridStepY-5));
    }
  }
  else
  {
    for (ind=0; ind <= Ystep; ind++)
    {
       text(MinY+(ScaleYstep*ind), -5, -(ind*GridStepY-5));
    }
  }
  Yscale = get(10,10,45,770);

  rotate(PI);
  rotate(HALF_PI);
  for (ind=1; ind < Ystep; ind++)
  {
     line( (int)(ind*GridStepY), 3, (int)(ind*GridStepY), Xsize-3);
  }
  
  for (ind=1; ind < Xstep; ind++)
  {
     line( 3, (int)(ind*GridStepX), Ysize-3, (int)(ind*GridStepX));
  }
  
  for (ind=1; ind < YstepSmall; ind++)
  {
     line( (int)(ind*GridStepYsmall), Xkofst-5, (int)(ind*GridStepYsmall), Xkofst+5);
  }
  
  for (ind=1; ind < XstepSmall; ind++)
  {
     line( Ykofst-5, (int)(ind*GridStepXsmall), Ykofst+5, (int)(ind*GridStepXsmall));
  }

  if (Flag == 3)
  {
     for (ind=1; ind < XstepSmall; ind++)
     {
       line( Ysize/4-5, (int)(ind*GridStepXsmall), Ysize/4+5, (int)(ind*GridStepXsmall));
       line( Ysize-Ysize/4-5, (int)(ind*GridStepXsmall), Ysize-Ysize/4+5, (int)(ind*GridStepXsmall));
     }
  } 
  popMatrix();
}

public int XGraph(int X)
{
  int Xnew;
  Xnew = (int)(X * Xk + Xkofst);
  return Xnew;
}

public int YGraph(int Y)
{
  int Ynew;
  Ynew = (int)(Y * Yk + Ykofst);
  return Ynew;
}

public void MyLine (int X0, int Y0, int X1, int Y1)
{
  pushMatrix();
  translate(RelX0,RelY0);
  rotate(-HALF_PI);
  line (YGraph(Y0), XGraph(X0), YGraph(Y1), XGraph(X1));
  popMatrix();
}
/*-----------------------------------------------------------------------------*/  
public void MainPanel()  // Main panel controls
{
    Grid = get(57,21,751,751);
    background(bg);
    image(Grid,57,21);
    image(Xscale,30,775);
    image(Yscale,10,10);
    
    BtnConfig.update();
    if (BtnConfig.released)
    {
      PanelIndx = 2;
      InputFieldsConfig();
      background(bg);
      textFont(CharFont, 15); 
//      MeanValues.flush();
//      MeanValues.close();
    }
    BtnConfig.display();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {
//      MeanValues.flush();
//      MeanValues.close();
      exit();
    }
    BtnQuit.display();
    
    BtnSendSpeed.update();
    if (BtnSendSpeed.released)
    {
      // 1 int (range -500 mm/s +500 mm/s)
      DesSpeed = RangeCheckInt(InputSpeed.getValue(), -500, 500);
      InputSpeed.setValue(nf(DesSpeed,3));
      TxIntValue[0] = DesSpeed;
      TxData(0, 'S', 1, 1);
    }
    BtnSendSpeed.display();
    
    BtnSendXY.update();
    if (BtnSendXY.released)
    {
      //2 int ( X, Y) (range -20000 mm +20000 mm)
      DesCoordX = RangeCheckInt(InputCoordX.getValue(), -20000, 20000);
      InputCoordX.setValue(nf(DesCoordX,4));
      DesCoordY = RangeCheckInt(InputCoordY.getValue(), -20000, 20000);
      InputCoordY.setValue(nf(DesCoordY,4));
      TxIntValue[0] = DesCoordX;
      TxIntValue[1] = DesCoordY;
      TxData(0, 'P', 2, 1);
    }
    BtnSendXY.display();
    
    BtnSendDist.update();
    if (BtnSendDist.released)
    {
      // 1 int (range -20000 mm + 20000 mm)
      DesDist = RangeCheckInt(InputDist.getValue(), -20000, 20000);
      InputDist.setValue(nf(DesDist,4));
      TxIntValue[0] = DesDist;
      TxData(0, 'D', 1, 1);
    }
    BtnSendDist.display();
    
    BtnSendReset.update();
    if (BtnSendReset.released)
    {
      StopFlag = true;
      Delay(10);
      TxData(0, '*', 0, 1);
    }
    BtnSendReset.display();
    
    BtnStartSeq.update();
    if (BtnStartSeq.released)
    {
      TxData(0, '#', 0, 1);
    }
    BtnStartSeq.display();
    
    BtnSendHalt.update();
    if (BtnSendHalt.released)
    {
      TxData(0, 'H', 0, 1);
    }
    BtnSendHalt.display();
    
    if (DebugFlag)
    {
      BtnDebugOn.update();
      if (BtnDebugOn.released)
      {
        DebugFlag=false;
        TxIntValue[0] = 0;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOn.display();
    }
    else
    {
      BtnDebugOn.display();
      BtnDebugOff.update();
      if (BtnDebugOff.released)
      {
        DebugFlag=true;
        TxIntValue[0] = 1;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOff.display();
    }
    
    if (StopFlag)
    {
      BtnStopOn.update();
      if (BtnStopOn.released)
      {
      if (!PreInitRS232Flag)
        {
          StopFlag=false;
        }
      }
      BtnStopOn.display();
    }
    else
    {
      BtnStopOn.display();
      BtnStopOff.update();
      if (BtnStopOff.released)
      {
        StopFlag=true;
      }
      BtnStopOff.display();
    }
    
    BtnSendVersion.update();
    if (BtnSendVersion.released)
    {
      int VerLen = 26;
      TxData(0, 'R', 0, 1);  // ask for all parameters
      Delay(VerLen);         // wait for data to be received
      
      if (PreInitRS232Flag)
      {
        SimulationRxVer();      // simulation
      }
    
      if (RxData('R',VerLen))
      {
        for (i=HeadLen; i < VerLen+HeadLen; i++)
        {
          Ver[i-HeadLen]= (char)(RxBuff[i]);
        }
      }
    }
    textAlign(LEFT);
    textFont(CharFont,10);
    text("X: "+Xpos,700,20);
    text("Y: "+Ypos,760,20);
    textAlign(RIGHT);
    String VerS = new String(Ver);
    textFont(CharFont, 15); 
    text(VerS, 1148, 672); 
    BtnSendVersion.display();
    
    KnobSegment(); 
    GaugeAngle();
    GaugeSpeed();
    GaugeCurrent();
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
public void ConfigPanel()  // Config panel controls
{
    int Kp;
    int Ki;
    int Kd;
    int K;
    int Wheel1;
    int Wheel2;
    int Cpr;
    int Gear;
    long Ksp1;
    long Ksp2;
    float Kvel1;
    float Kvel2;
    float Fcy = 39.628800f;
    
    background(bgConfig);
    text("Last Error",1230,505);
    text(ErrorCode,1230,525);
    BtnRun.display();
    BtnRun.update();
    
    textFont(CharFont, 8); 
    
    BtnSeqL.update();
    if (BtnSeqL.released)
    {
      PanelIndx = 4;
      InputFieldsSequencer();
      background(bgSequencer);
      textFont(CharFont, 15); 
    }
    BtnSeqL.display();
    
    BtnSendCfgKSpeed1.update();
    if (BtnSendCfgKSpeed1.released)
    {
      // 6 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputSpeed1Kp.getValue(), 0, 9999);
      InputSpeed1Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed1Ki.getValue(), 0, 9999);
      InputSpeed1Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed1Kd.getValue(), 0, 9999);
      InputSpeed1Kd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      Kp = RangeCheckInt(InputSpeed2Kp.getValue(), 0, 9999);
      InputSpeed2Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed2Ki.getValue(), 0, 9999);
      InputSpeed2Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed2Kd.getValue(), 0, 9999);
      InputSpeed2Kd.setValue(nf(Kd,0));
      TxIntValue[3] = Kp;
      TxIntValue[4] = Ki;
      TxIntValue[5] = Kd;
      TxData(0, 'K', 6, 1);
    }
    BtnSendCfgKSpeed1.display();
   
    BtnSendCfgKAngle.update();
    if (BtnSendCfgKAngle.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputAngleKp.getValue(), 0, 9999);
      InputAngleKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputAngleKi.getValue(), 0, 9999);
      InputAngleKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputAngleKd.getValue(), 0, 9999);
      InputAngleKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'k', 3, 1);
    }
    BtnSendCfgKAngle.display();
    
    BtnSendCfgKDist.update();
    if (BtnSendCfgKDist.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputDistKp.getValue(), 0, 9999);
      InputDistKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputDistKi.getValue(), 0, 9999);
      InputDistKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputDistKd.getValue(), 0, 9999);
      InputDistKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'J', 3, 1);
    }
    BtnSendCfgKDist.display();


    BtnSendCfgWheels.update();
    if (BtnSendCfgWheels.released)
    {
      /* Axle size (pico meters) 
         Ksp = constants for traveled distance calculation: 
         SPACE_ENC_4X (micron / 1.000.000 = picoM)
         3  long 
         
         Speed calculation K in micron/second = 401.1588
	 Speed calculation K in m/s as a power of 2 to semplify dsPID elaboration
	 Kvel[] << 15 ( x 2^15) 
         2 long, 2 x 4 bytes
         for a detailde description see descrEng.txt in dsPID33 folder
         
         All values are computed starting from mechanical parameters of the wheels 
         and the encoders
      */
      
      K = RangeCheckInt(InputAxle.getValue(), 0, 999999999);
      InputAxle.setValue(nf(K,0));
            
      Wheel1 = RangeCheckInt(InputWheel1.getValue(), 0, 999999999);
      InputWheel1.setValue(nf(Wheel1,0));

      Wheel2 = RangeCheckInt(InputWheel2.getValue(), 0, 999999999);
      InputWheel2.setValue(nf(Wheel2,0));

      Cpr = RangeCheckInt(InputCpr.getValue(), 0, 9999);
      InputCpr.setValue(nf(Cpr,0));
      
      Gear = RangeCheckInt(InputGear.getValue(), 0, 999);
      InputGear.setValue(nf(Gear,0));
      
      Ksp1 = (long)((Wheel1*PI*1000)/(Cpr*Gear*4));
      Ksp2 = (long)((Wheel2*PI*1000)/(Cpr*Gear*4));
      TxIntValue[0] = K/100;
      TxIntValue[1] = (int)(Ksp1);
      TxIntValue[2] = (int)(Ksp2);
      TxData(0, 'M', 3, 2);

      Delay(2);
      
      Kvel1=((((Wheel1*PI) /(Cpr*Gear)) *Fcy)/1000)*32768;
      Kvel2=((((Wheel2*PI) /(Cpr*Gear)) *Fcy)/1000)*32768;
      TxIntValue[0] = (int)(Kvel1);
      TxIntValue[1] = (int)(Kvel2);
      TxData(0, 'L', 2, 2);
    }
    BtnSendCfgWheels.display();

    BtnSendCfgRS232.update();
    if (BtnSendCfgRS232.released)
    {
       RS232ComPort = RangeCheckInt(InputRS232Com.getValue(), 0, SerialList.length-1);
       RS232Bps = RangeCheckInt(InputRS232bps.getValue(), 1200, 115200);
       try
       { 
          if (! SimulationRS232Flag)
          {
            RS232Port = new Serial(this, Serial.list()[RS232ComPort], RS232Bps);
            PreInitRS232Flag = false;          // turn ON real RS232 sending
          }
          else
          {
            PreInitRS232Flag = true;          // still in simulation
          }
          CharTime = (115200 / RS232Bps) * 1.5f; // waiting time is a function of bps
          RS232Port.clear();
        }
        catch(Exception e)    // not a valid COM port
        {
          RS232ComPort = 99;
          PreInitRS232Flag = true;          // turn OFF real RS232 sending
        } 

       InputRS232Com.setValue(nf(RS232ComPort,0));
       InputRS232bps.setValue(nf(RS232Bps,0));
    }
    BtnSendCfgRS232.display();
    
    BtnSendError.update();
    if (BtnSendError.released)
    {
      TxData(0, 'e', 0, 1);
      Delay(2);              // wait for data to be received
      if (RxData('e',2))
      {// two bytes -> i int
        ErrorCode = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
      }
    }
    BtnSendError.display();
     
    BtnSendCfgLoad.update();
    if (BtnSendCfgLoad.released)
    {
      LoadCfg();
    }
    BtnSendCfgLoad.display();
    
    BtnSendCfgSave.update();
    if (BtnSendCfgSave.released)
    {
      SaveCfg();
    }
    BtnSendCfgSave.display();
    
    BtnSendMainGrid.update();
    if (BtnSendMainGrid.released)
    {
      MainGridMinX =  Integer.parseInt(InputMGXmin.getValue());
      MainGridMaxX =  Integer.parseInt(InputMGXmax.getValue());
      MainGridMinY =  Integer.parseInt(InputMGYmin.getValue());
      MainGridMaxY =  Integer.parseInt(InputMGYmax.getValue());
      MainGridXstep =  Integer.parseInt(InputMGXstep.getValue());
      MainGridYstep =  Integer.parseInt(InputMGYstep.getValue());
      MainGridXstepSmall =  Integer.parseInt(InputMGXSteps.getValue());
      MainGridYstepSmall =  Integer.parseInt(InputMGYSteps.getValue());
    }
    BtnSendMainGrid.display();
    
    BtnSendMainSet.update();
    if (BtnSendMainSet.released)
    {
      MainGridSet =  RangeCheckInt(InputMGset.getValue(), 1, 8);
      InputMGset.setValue(nf(MainGridSet,0));
      switch (MainGridSet)
      {
        case 1:
          MainGridMinX =  -5000;
          MainGridMaxX =  5000;
          MainGridMinY =  -5000;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 2:
          MainGridMinX =  -10000;
          MainGridMaxX =  10000;
          MainGridMinY =  -10000;
          MainGridMaxY =  10000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 3:
          MainGridMinX =  -15000;
          MainGridMaxX =  15000;
          MainGridMinY =  -15000;
          MainGridMaxY =  15000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 4:
          MainGridMinX =  -20000;
          MainGridMaxX =  20000;
          MainGridMinY =  -20000;
          MainGridMaxY =  20000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 5:
          MainGridMinX =  0;
          MainGridMaxX =  5000;
          MainGridMinY =  0;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 6:
          MainGridMinX =  0;
          MainGridMaxX =  10000;
          MainGridMinY =  0;
          MainGridMaxY =  10000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 7:
          MainGridMinX =  0;
          MainGridMaxX =  15000;
          MainGridMinY =  0;
          MainGridMaxY =  15000;
          MainGridXstep =  15;
          MainGridYstep =  15;
          MainGridXstepSmall =  75;
          MainGridYstepSmall =  75;
        break;
        
        case 8:
          MainGridMinX =  0;
          MainGridMaxX =  20000;
          MainGridMinY =  0;
          MainGridMaxY =  20000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;

        default:
          MainGridMinX =  -5000;
          MainGridMaxX =  5000;
          MainGridMinY =  -5000;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
      }
       InputMGXmin.setValue(nf(MainGridMinX,0));
       InputMGXmax.setValue(nf(MainGridMaxX,0));
       InputMGYmin.setValue(nf(MainGridMinY,0));
       InputMGYmax.setValue(nf(MainGridMaxY,0));
       InputMGXstep.setValue(nf(MainGridXstep,0));
       InputMGYstep.setValue(nf(MainGridYstep,0));
       InputMGXSteps.setValue(nf(MainGridXstepSmall,0));
       InputMGYSteps.setValue(nf(MainGridYstepSmall,0));
    }
    BtnSendMainSet.display();

    BtnSendDetailGrid.update();
    if (BtnSendDetailGrid.released)
    {
      DetailGridMinX =  Integer.parseInt(InputDGXmin.getValue());
      DetailGridMaxX =  Integer.parseInt(InputDGXmax.getValue());
      DetailGridMinY =  Integer.parseInt(InputDGYmin.getValue());
      DetailGridMaxY =  Integer.parseInt(InputDGYmax.getValue());
      DetailGridXstep =  Integer.parseInt(InputDGXstep.getValue());
      DetailGridYstep =  Integer.parseInt(InputDGYstep.getValue());
      DetailGridXstepSmall =  Integer.parseInt(InputDGXSteps.getValue());
      DetailGridYstepSmall =  Integer.parseInt(InputDGYSteps.getValue());
    }
    BtnSendDetailGrid.display();

    BtnSendDetailSet.update();
    if (BtnSendDetailSet.released)
    {
      DetailGridSet =  RangeCheckInt(InputDGset.getValue(), 1, 6);
      InputDGset.setValue(nf(DetailGridSet,0));
      switch (DetailGridSet)
      {
        case 1:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  15;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
        
        case 2:
          DetailGridMinX =  -200;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  10;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  100;
        break;
        
        case 3:
          DetailGridMinX =  -300;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  10;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
        
        case 4:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  15;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  120;
        break;
        
        case 5:
          DetailGridMinX =  -200;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  10;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  120;
        break;
        
        case 6:
          DetailGridMinX =  -300;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  10;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  120;
        break;
 
        default:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  15;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
      }
       InputDGXmin.setValue(nf(DetailGridMinX,0));
       InputDGXmax.setValue(nf(DetailGridMaxX,0));
       InputDGYmin.setValue(nf(DetailGridMinY,0));
       InputDGYmax.setValue(nf(DetailGridMaxY,0));
       InputDGXstep.setValue(nf(DetailGridXstep,0));
       InputDGYstep.setValue(nf(DetailGridYstep,0));
       InputDGXSteps.setValue(nf(DetailGridXstepSmall,0));
       InputDGYSteps.setValue(nf(DetailGridYstepSmall,0));
    }
    BtnSendDetailSet.display();
    
    BtnSendCycle.update();
    if (BtnSendCycle.released)
    {
      CyclePeriod = RangeCheckInt(InputCycle.getValue(),100,1000);
      InputCycle.setValue(nf(CyclePeriod,0));
    }
    BtnSendCycle.display();
   
      textFont(CharFont, 15); 
      textAlign(LEFT);
      text("Available COM ports:",800,480);
      for(i=0;i<(SerialList.length);i++)
      {
        if (i == RS232ComPort)
        {
          fill(0,100,255);
        }
        else
        {
          fill(255,255,255);
        }
        text(i + " = " + SerialList[i],810,500 + (i*20));
      }
      fill(255,255,255);
      
   if (BtnRun.released)  
    {
      PanelIndx = 1;
      InputFieldsRun();
      background(bg);
      textFont(CharFont, 15); 
      DefineMainGrid();
      Grid = get(57,21,751,751);

//      MeanValues.flush(); 
    }
    BtnRun.display();
    
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
public void DetailsPanel()  // Details panel controls
{
    background(bgDetails);
    image(Grid,57,21);
    image(Xscale,30,775);
    image(Yscale,10,10);    
    Plot();
    
    BtnSeqR.update();
    if (BtnSeqR.released)
    {
      PanelIndx = 4;
      InputFieldsSequencer();
      background(bgSequencer);
      textFont(CharFont, 15); 
    }
    BtnSeqR.display();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {
//      DetailValues.flush();
//      DetailValues.close();
      exit();
    }
    BtnQuit.display();
    
    BtnSendSpeed.update();
    if (BtnSendSpeed.released)
    {
      // 1 int (range -500 mm/s +500 mm/s)
      DesSpeed = RangeCheckInt(InputSpeed.getValue(), -500, 500);
      InputSpeed.setValue(nf(DesSpeed,3));
      TxIntValue[0] = DesSpeed;
      TxData(0, 'S', 1, 1);
    }
    BtnSendSpeed.display();
    
    BtnStartSeq.update();
    if (BtnStartSeq.released)
    {
      TxData(0, '#', 0, 1);
    }
    BtnStartSeq.display();
    
    BtnSendXY.update();
    if (BtnSendXY.released)
    {
      //2 int ( X, Y) (range -5000 mm +5000 mm)
      DesCoordX = RangeCheckInt(InputCoordX.getValue(), -5000, 5000);
      InputCoordX.setValue(nf(DesCoordX,4));
      DesCoordY = RangeCheckInt(InputCoordY.getValue(), -5000, 5000);
      InputCoordY.setValue(nf(DesCoordY,4));
      TxIntValue[0] = DesCoordX;
      TxIntValue[1] = DesCoordY;
      TxData(0, 'P', 2, 1);
    }
    BtnSendXY.display();
    
    BtnSendDist.update();
    if (BtnSendDist.released)
    {
      // 1 int (range -5000 mm + 5000 mm)
      DesDist = RangeCheckInt(InputDist.getValue(), -5000, 50000);
      InputDist.setValue(nf(DesDist,4));
      TxIntValue[0] = DesDist;
      TxData(0, 'D', 1, 1);
    }
    BtnSendDist.display();
    
    BtnSendReset.update();
    if (BtnSendReset.released)
    {
      StopFlag = true;
      Delay(10);
      TxData(0, '*', 0, 1);
    }
    BtnSendReset.display();
    
    BtnSendHalt.update();
    if (BtnSendHalt.released)
    {
      TxData(0, 'H', 0, 1);
    }
    BtnSendHalt.display();
    
    if (DebugFlag)
    {
      BtnDebugOn.update();
      if (BtnDebugOn.released)
      {
        DebugFlag=false;
        TxIntValue[0] = 0;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOn.display();
    }
    else
    {
      BtnDebugOn.display();
      BtnDebugOff.update();
      if (BtnDebugOff.released)
      {
        DebugFlag=true;
        TxIntValue[0] = 1;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOff.display();
    }
    
    if (StopFlag)
    {
      BtnStopOn.update();
      if (BtnStopOn.released)
      {
      if (!PreInitRS232Flag)
        {
          StopFlag=false;
        }
      }
      BtnStopOn.display();
    }
    else
    {
      BtnStopOn.display();
      BtnStopOff.update();
      if (BtnStopOff.released)
      {
        StopFlag=true;
      }
      BtnStopOff.display();
    }
    
    BtnSendVersion.update();
    if (BtnSendVersion.released)
    {
      int VerLen = 26;
      TxData(0, 'R', 0, 1);  // ask for all parameters
      Delay(VerLen);         // wait for data to be received
      
      if (PreInitRS232Flag)
      {
        SimulationRxVer();      // simulation
      }
    
      if (RxData('R',VerLen))
      {
        for (i=HeadLen; i < VerLen+HeadLen; i++)
        {
          Ver[i-HeadLen]= (char)(RxBuff[i]);
        }
      }
    }
    textAlign(RIGHT);
    String VerS = new String(Ver);
    textFont(CharFont, 15); 
    text(VerS, 1148, 672); 
    BtnSendVersion.display();
    
    KnobSegment(); 
 //   GaugeAngle();
    GaugeCurrentL();
    GaugeCurrentR();
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
public void SequencerPanel()  // Sequencer panel controls
{
    background(bgSequencer);
    
    textFont(CharFont, 8); 
    
    BtnConfig.update();
    if (BtnConfig.released)
    {
      PanelIndx = 2;
      InputFieldsConfig();
      background(bg);
      textFont(CharFont, 15); 
    }
    BtnConfig.display();
    
    BtnDet.update();
    if (BtnDet.released)
    {
      PanelIndx = 3;
      InputFieldsDetails();
      background(bgDetails);
      textFont(CharFont, 15); 
      DefineDetailsGrid();
      Grid = get(57,21,751,751);
    }
    BtnDet.display();
    
     
    BtnSendCfgLoad.update();
    if (BtnSendCfgLoad.released)
    {
      LoadCfg();
    }
    BtnSendCfgLoad.display();
    
    BtnSendCfgSave.update();
    if (BtnSendCfgSave.released)
    {
      SaveCfg();
    }
    BtnSendCfgSave.display();
    
 
textFont(FixFont, 15); 
textAlign(LEFT);
int TextX = 700;
int TextY = 480;
int TextS = 15;
// text("Sequencer code description",TextX,TextY+TextS*0);
text("Code Meaning Description                         A   B   C",TextX,TextY+TextS*1);
text("0    stop    end of sequence                            ",TextX,TextY+TextS*2);
text("1    Vel     keep angle-set speed                V      ",TextX,TextY+TextS*3);
text("2    Dist    keep angle and speed-set distance   V   D   ",TextX,TextY+TextS*4);
text("3    Angle   keep speed-set angle                V   Phi ",TextX,TextY+TextS*5);
text("4    Angle   keep speed-set angle toward X, Y    V   X   Y",TextX,TextY+TextS*6);
text("5    Speed   keep speed-walk toward X, Y         V   X   Y",TextX,TextY+TextS*7);
text("6    Delay   wait n x 50ms                       Time     ",TextX,TextY+TextS*8);

text("Units",TextX,TextY+TextS*10);
text("  Angle=deg, Speed=mm/s, X-Y=mm, Delay=n x 50ms",TextX,TextY+TextS*11);

textFont(CharFont, 15); 

      fill(255,255,255);
      
/*   if (BtnRun.released)  
    {
      PanelIndx = 1;
      InputFieldsRun();
      background(bg);
      textFont(CharFont, 15); 
      DefineMainGrid();
      Grid = get(57,21,751,751);
    }
    BtnRun.display();
*/
    
    ReleasedFlag = false;
}


/*-----------------------------------------------------------------------------*/
public void KnobSegment()  // draw knob index
{
  float KnobX = 1162;
  float KnobY = 333;
  float KnobSegLength = 50;
  float KnobDx = mouseX - KnobX;
  float KnobDy = mouseY - KnobY;
  int Base = 3;
  pushMatrix();
  translate(KnobX, KnobY);
  if (mouseX >= KnobX-KnobSegLength && mouseX <= KnobX+KnobSegLength && 
      mouseY >= KnobY-KnobSegLength && mouseY <= KnobY+KnobSegLength &&
      mousePressed)
    {
      KnobAngle = atan2(KnobDy, KnobDx);  
    }
   rotate(KnobAngle);
   strokeWeight(7.0f);
   stroke(67,85,100);
   triangle(0,-Base,0,Base,KnobSegLength,0);
   popMatrix();
   KnobAngle1=degrees(KnobAngle+(PI/2));
   textAlign(CENTER);
   text(nf(KnobAngle1,0,1), KnobX,KnobY+115);
   DesAngle = KnobAngle1;
}

/*-----------------------------------------------------------------------------*/
public void GaugeAngle()
{
  float GaugeX = 950;
  float GaugeY = 333;
  float GaugeSegLength = 60;
  float Angle1 = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
   rotate(radians(MesAngle-90));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   Angle1 = (MesAngle);
//      Angle1 = degrees(MesAngle+(PI/2));
   textAlign(CENTER);
   text(nf(Angle1,0,1), GaugeX,GaugeY+112);
}

/*-----------------------------------------------------------------------------*/
public void GaugeSpeed()
{
  float GaugeX = 950;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Speed1;
  float MinSpeed=-500;
  float MaxSpeed=500;
  float Speed = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Speed = MesSpeed;
  if (Speed > 500) Speed = 500;
  if (Speed < -500) Speed = -500;
  Speed1 = Speed * (300 / (MaxSpeed-MinSpeed));
  Speed1=radians(Speed1-90);
   rotate((Speed1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Speed,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
public void GaugeCurrent()
{
  float GaugeX = 1168;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = Current * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Current,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
public void GaugeCurrentR()
{
  float GaugeX = 1168;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = CurrentR * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(CurrentR,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
public void GaugeCurrentL()
{
  float GaugeX = 950;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = CurrentL * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(CurrentL,0,1), GaugeX,GaugeY+105);
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#c0c0c0", "dsNavConConsole" });
  }
}
