/*-----------------------------------------------------------------------------*/  
void MainPanel()  // Main panel controls
{
    Grid = get(57,21,751,751);
    background(bg);
    image(Grid,57,21);
    image(Xscale,30,775);
    image(Yscale,10,10);
    
    BtnConfig.update();
    if (BtnConfig.released)
    {
      PanelIndx = 2;
      InputFieldsConfig();
      background(bg);
      textFont(CharFont, 15); 
//      MeanValues.flush();
//      MeanValues.close();
    }
    BtnConfig.display();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {
//      MeanValues.flush();
//      MeanValues.close();
      exit();
    }
    BtnQuit.display();
    
    BtnSendSpeed.update();
    if (BtnSendSpeed.released)
    {
      // 1 int (range -500 mm/s +500 mm/s)
      DesSpeed = RangeCheckInt(InputSpeed.getValue(), -500, 500);
      InputSpeed.setValue(nf(DesSpeed,3));
      TxIntValue[0] = DesSpeed;
      TxData(0, 'S', 1, 1);
    }
    BtnSendSpeed.display();
    
    BtnSendXY.update();
    if (BtnSendXY.released)
    {
      //2 int ( X, Y) (range -20000 mm +20000 mm)
      DesCoordX = RangeCheckInt(InputCoordX.getValue(), -20000, 20000);
      InputCoordX.setValue(nf(DesCoordX,4));
      DesCoordY = RangeCheckInt(InputCoordY.getValue(), -20000, 20000);
      InputCoordY.setValue(nf(DesCoordY,4));
      TxIntValue[0] = DesCoordX;
      TxIntValue[1] = DesCoordY;
      TxData(0, 'P', 2, 1);
    }
    BtnSendXY.display();
    
    BtnSendDist.update();
    if (BtnSendDist.released)
    {
      // 1 int (range -20000 mm + 20000 mm)
      DesDist = RangeCheckInt(InputDist.getValue(), -20000, 20000);
      InputDist.setValue(nf(DesDist,4));
      TxIntValue[0] = DesDist;
      TxData(0, 'D', 1, 1);
    }
    BtnSendDist.display();
    
    BtnSendReset.update();
    if (BtnSendReset.released)
    {
      StopFlag = true;
      Delay(10);
      TxData(0, '*', 0, 1);
    }
    BtnSendReset.display();
    
    BtnStartSeq.update();
    if (BtnStartSeq.released)
    {
      TxData(0, '#', 0, 1);
    }
    BtnStartSeq.display();
    
    BtnSendHalt.update();
    if (BtnSendHalt.released)
    {
      TxData(0, 'H', 0, 1);
    }
    BtnSendHalt.display();
    
    if (DebugFlag)
    {
      BtnDebugOn.update();
      if (BtnDebugOn.released)
      {
        DebugFlag=false;
        TxIntValue[0] = 0;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOn.display();
    }
    else
    {
      BtnDebugOn.display();
      BtnDebugOff.update();
      if (BtnDebugOff.released)
      {
        DebugFlag=true;
        TxIntValue[0] = 1;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOff.display();
    }
    
    if (StopFlag)
    {
      BtnStopOn.update();
      if (BtnStopOn.released)
      {
      if (!PreInitRS232Flag)
        {
          StopFlag=false;
        }
      }
      BtnStopOn.display();
    }
    else
    {
      BtnStopOn.display();
      BtnStopOff.update();
      if (BtnStopOff.released)
      {
        StopFlag=true;
      }
      BtnStopOff.display();
    }
    
    BtnSendVersion.update();
    if (BtnSendVersion.released)
    {
      int VerLen = 26;
      TxData(0, 'R', 0, 1);  // ask for all parameters
      Delay(VerLen);         // wait for data to be received
      
      if (PreInitRS232Flag)
      {
        SimulationRxVer();      // simulation
      }
    
      if (RxData('R',VerLen))
      {
        for (i=HeadLen; i < VerLen+HeadLen; i++)
        {
          Ver[i-HeadLen]= (char)(RxBuff[i]);
        }
      }
    }
    textAlign(LEFT);
    textFont(CharFont,10);
    text("X: "+Xpos,700,20);
    text("Y: "+Ypos,760,20);
    textAlign(RIGHT);
    String VerS = new String(Ver);
    textFont(CharFont, 15); 
    text(VerS, 1148, 672); 
    BtnSendVersion.display();
    
    KnobSegment(); 
    GaugeAngle();
    GaugeSpeed();
    GaugeCurrent();
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
void ConfigPanel()  // Config panel controls
{
    int Kp;
    int Ki;
    int Kd;
    int K;
    int Wheel1;
    int Wheel2;
    int Cpr;
    int Gear;
    long Ksp1;
    long Ksp2;
    float Kvel1;
    float Kvel2;
    float Fcy = 39.628800;
    
    background(bgConfig);
    text("Last Error",1230,505);
    text(ErrorCode,1230,525);
    BtnRun.display();
    BtnRun.update();
    
    textFont(CharFont, 8); 
    
    BtnSeqL.update();
    if (BtnSeqL.released)
    {
      PanelIndx = 4;
      InputFieldsSequencer();
      background(bgSequencer);
      textFont(CharFont, 15); 
    }
    BtnSeqL.display();
    
    BtnSendCfgKSpeed1.update();
    if (BtnSendCfgKSpeed1.released)
    {
      // 6 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputSpeed1Kp.getValue(), 0, 9999);
      InputSpeed1Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed1Ki.getValue(), 0, 9999);
      InputSpeed1Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed1Kd.getValue(), 0, 9999);
      InputSpeed1Kd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      Kp = RangeCheckInt(InputSpeed2Kp.getValue(), 0, 9999);
      InputSpeed2Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed2Ki.getValue(), 0, 9999);
      InputSpeed2Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed2Kd.getValue(), 0, 9999);
      InputSpeed2Kd.setValue(nf(Kd,0));
      TxIntValue[3] = Kp;
      TxIntValue[4] = Ki;
      TxIntValue[5] = Kd;
      TxData(0, 'K', 6, 1);
    }
    BtnSendCfgKSpeed1.display();
   
    BtnSendCfgKAngle.update();
    if (BtnSendCfgKAngle.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputAngleKp.getValue(), 0, 9999);
      InputAngleKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputAngleKi.getValue(), 0, 9999);
      InputAngleKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputAngleKd.getValue(), 0, 9999);
      InputAngleKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'k', 3, 1);
    }
    BtnSendCfgKAngle.display();
    
    BtnSendCfgKDist.update();
    if (BtnSendCfgKDist.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputDistKp.getValue(), 0, 9999);
      InputDistKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputDistKi.getValue(), 0, 9999);
      InputDistKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputDistKd.getValue(), 0, 9999);
      InputDistKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'J', 3, 1);
    }
    BtnSendCfgKDist.display();


    BtnSendCfgWheels.update();
    if (BtnSendCfgWheels.released)
    {
      /* Axle size (pico meters) 
         Ksp = constants for traveled distance calculation: 
         SPACE_ENC_4X (micron / 1.000.000 = picoM)
         3  long 
         
         Speed calculation K in micron/second = 401.1588
	 Speed calculation K in m/s as a power of 2 to semplify dsPID elaboration
	 Kvel[] << 15 ( x 2^15) 
         2 long, 2 x 4 bytes
         for a detailde description see descrEng.txt in dsPID33 folder
         
         All values are computed starting from mechanical parameters of the wheels 
         and the encoders
      */
      
      K = RangeCheckInt(InputAxle.getValue(), 0, 999999999);
      InputAxle.setValue(nf(K,0));
            
      Wheel1 = RangeCheckInt(InputWheel1.getValue(), 0, 999999999);
      InputWheel1.setValue(nf(Wheel1,0));

      Wheel2 = RangeCheckInt(InputWheel2.getValue(), 0, 999999999);
      InputWheel2.setValue(nf(Wheel2,0));

      Cpr = RangeCheckInt(InputCpr.getValue(), 0, 9999);
      InputCpr.setValue(nf(Cpr,0));
      
      Gear = RangeCheckInt(InputGear.getValue(), 0, 999);
      InputGear.setValue(nf(Gear,0));
      
      Ksp1 = (long)((Wheel1*PI*1000)/(Cpr*Gear*4));
      Ksp2 = (long)((Wheel2*PI*1000)/(Cpr*Gear*4));
      TxIntValue[0] = K/100;
      TxIntValue[1] = (int)(Ksp1);
      TxIntValue[2] = (int)(Ksp2);
      TxData(0, 'M', 3, 2);

      Delay(2);
      
      Kvel1=((((Wheel1*PI) /(Cpr*Gear)) *Fcy)/1000)*32768;
      Kvel2=((((Wheel2*PI) /(Cpr*Gear)) *Fcy)/1000)*32768;
      TxIntValue[0] = (int)(Kvel1);
      TxIntValue[1] = (int)(Kvel2);
      TxData(0, 'L', 2, 2);
    }
    BtnSendCfgWheels.display();

    BtnSendCfgRS232.update();
    if (BtnSendCfgRS232.released)
    {
       RS232ComPort = RangeCheckInt(InputRS232Com.getValue(), 0, SerialList.length-1);
       RS232Bps = RangeCheckInt(InputRS232bps.getValue(), 1200, 115200);
       try
       { 
          if (! SimulationRS232Flag)
          {
            RS232Port = new Serial(this, Serial.list()[RS232ComPort], RS232Bps);
            PreInitRS232Flag = false;          // turn ON real RS232 sending
          }
          else
          {
            PreInitRS232Flag = true;          // still in simulation
          }
          CharTime = (115200 / RS232Bps) * 1.5; // waiting time is a function of bps
          RS232Port.clear();
        }
        catch(Exception e)    // not a valid COM port
        {
          RS232ComPort = 99;
          PreInitRS232Flag = true;          // turn OFF real RS232 sending
        } 

       InputRS232Com.setValue(nf(RS232ComPort,0));
       InputRS232bps.setValue(nf(RS232Bps,0));
    }
    BtnSendCfgRS232.display();
    
    BtnSendError.update();
    if (BtnSendError.released)
    {
      TxData(0, 'e', 0, 1);
      Delay(2);              // wait for data to be received
      if (RxData('e',2))
      {// two bytes -> i int
        ErrorCode = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
      }
    }
    BtnSendError.display();
     
    BtnSendCfgLoad.update();
    if (BtnSendCfgLoad.released)
    {
      LoadCfg();
    }
    BtnSendCfgLoad.display();
    
    BtnSendCfgSave.update();
    if (BtnSendCfgSave.released)
    {
      SaveCfg();
    }
    BtnSendCfgSave.display();
    
    BtnSendMainGrid.update();
    if (BtnSendMainGrid.released)
    {
      MainGridMinX =  Integer.parseInt(InputMGXmin.getValue());
      MainGridMaxX =  Integer.parseInt(InputMGXmax.getValue());
      MainGridMinY =  Integer.parseInt(InputMGYmin.getValue());
      MainGridMaxY =  Integer.parseInt(InputMGYmax.getValue());
      MainGridXstep =  Integer.parseInt(InputMGXstep.getValue());
      MainGridYstep =  Integer.parseInt(InputMGYstep.getValue());
      MainGridXstepSmall =  Integer.parseInt(InputMGXSteps.getValue());
      MainGridYstepSmall =  Integer.parseInt(InputMGYSteps.getValue());
    }
    BtnSendMainGrid.display();
    
    BtnSendMainSet.update();
    if (BtnSendMainSet.released)
    {
      MainGridSet =  RangeCheckInt(InputMGset.getValue(), 1, 8);
      InputMGset.setValue(nf(MainGridSet,0));
      switch (MainGridSet)
      {
        case 1:
          MainGridMinX =  -5000;
          MainGridMaxX =  5000;
          MainGridMinY =  -5000;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 2:
          MainGridMinX =  -10000;
          MainGridMaxX =  10000;
          MainGridMinY =  -10000;
          MainGridMaxY =  10000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 3:
          MainGridMinX =  -15000;
          MainGridMaxX =  15000;
          MainGridMinY =  -15000;
          MainGridMaxY =  15000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 4:
          MainGridMinX =  -20000;
          MainGridMaxX =  20000;
          MainGridMinY =  -20000;
          MainGridMaxY =  20000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 5:
          MainGridMinX =  0;
          MainGridMaxX =  5000;
          MainGridMinY =  0;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 6:
          MainGridMinX =  0;
          MainGridMaxX =  10000;
          MainGridMinY =  0;
          MainGridMaxY =  10000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
        
        case 7:
          MainGridMinX =  0;
          MainGridMaxX =  15000;
          MainGridMinY =  0;
          MainGridMaxY =  15000;
          MainGridXstep =  15;
          MainGridYstep =  15;
          MainGridXstepSmall =  75;
          MainGridYstepSmall =  75;
        break;
        
        case 8:
          MainGridMinX =  0;
          MainGridMaxX =  20000;
          MainGridMinY =  0;
          MainGridMaxY =  20000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;

        default:
          MainGridMinX =  -5000;
          MainGridMaxX =  5000;
          MainGridMinY =  -5000;
          MainGridMaxY =  5000;
          MainGridXstep =  10;
          MainGridYstep =  10;
          MainGridXstepSmall =  50;
          MainGridYstepSmall =  50;
        break;
      }
       InputMGXmin.setValue(nf(MainGridMinX,0));
       InputMGXmax.setValue(nf(MainGridMaxX,0));
       InputMGYmin.setValue(nf(MainGridMinY,0));
       InputMGYmax.setValue(nf(MainGridMaxY,0));
       InputMGXstep.setValue(nf(MainGridXstep,0));
       InputMGYstep.setValue(nf(MainGridYstep,0));
       InputMGXSteps.setValue(nf(MainGridXstepSmall,0));
       InputMGYSteps.setValue(nf(MainGridYstepSmall,0));
    }
    BtnSendMainSet.display();

    BtnSendDetailGrid.update();
    if (BtnSendDetailGrid.released)
    {
      DetailGridMinX =  Integer.parseInt(InputDGXmin.getValue());
      DetailGridMaxX =  Integer.parseInt(InputDGXmax.getValue());
      DetailGridMinY =  Integer.parseInt(InputDGYmin.getValue());
      DetailGridMaxY =  Integer.parseInt(InputDGYmax.getValue());
      DetailGridXstep =  Integer.parseInt(InputDGXstep.getValue());
      DetailGridYstep =  Integer.parseInt(InputDGYstep.getValue());
      DetailGridXstepSmall =  Integer.parseInt(InputDGXSteps.getValue());
      DetailGridYstepSmall =  Integer.parseInt(InputDGYSteps.getValue());
    }
    BtnSendDetailGrid.display();

    BtnSendDetailSet.update();
    if (BtnSendDetailSet.released)
    {
      DetailGridSet =  RangeCheckInt(InputDGset.getValue(), 1, 6);
      InputDGset.setValue(nf(DetailGridSet,0));
      switch (DetailGridSet)
      {
        case 1:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  15;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
        
        case 2:
          DetailGridMinX =  -200;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  10;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  100;
        break;
        
        case 3:
          DetailGridMinX =  -300;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  10;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
        
        case 4:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  15;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  120;
        break;
        
        case 5:
          DetailGridMinX =  -200;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  10;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  120;
        break;
        
        case 6:
          DetailGridMinX =  -300;
          DetailGridMaxX =  0;
          DetailGridMinY =  -300;
          DetailGridMaxY =  300;
          DetailGridXstep =  10;
          DetailGridYstep =  24;
          DetailGridXstepSmall =  50;
          DetailGridYstepSmall =  120;
        break;
 
        default:
          DetailGridMinX =  -150;
          DetailGridMaxX =  0;
          DetailGridMinY =  -500;
          DetailGridMaxY =  500;
          DetailGridXstep =  15;
          DetailGridYstep =  20;
          DetailGridXstepSmall =  75;
          DetailGridYstepSmall =  100;
        break;
      }
       InputDGXmin.setValue(nf(DetailGridMinX,0));
       InputDGXmax.setValue(nf(DetailGridMaxX,0));
       InputDGYmin.setValue(nf(DetailGridMinY,0));
       InputDGYmax.setValue(nf(DetailGridMaxY,0));
       InputDGXstep.setValue(nf(DetailGridXstep,0));
       InputDGYstep.setValue(nf(DetailGridYstep,0));
       InputDGXSteps.setValue(nf(DetailGridXstepSmall,0));
       InputDGYSteps.setValue(nf(DetailGridYstepSmall,0));
    }
    BtnSendDetailSet.display();
    
    BtnSendCycle.update();
    if (BtnSendCycle.released)
    {
      CyclePeriod = RangeCheckInt(InputCycle.getValue(),100,1000);
      InputCycle.setValue(nf(CyclePeriod,0));
    }
    BtnSendCycle.display();
   
      textFont(CharFont, 15); 
      textAlign(LEFT);
      text("Available COM ports:",800,480);
      for(i=0;i<(SerialList.length);i++)
      {
        if (i == RS232ComPort)
        {
          fill(0,100,255);
        }
        else
        {
          fill(255,255,255);
        }
        text(i + " = " + SerialList[i],810,500 + (i*20));
      }
      fill(255,255,255);
      
   if (BtnRun.released)  
    {
      PanelIndx = 1;
      InputFieldsRun();
      background(bg);
      textFont(CharFont, 15); 
      DefineMainGrid();
      Grid = get(57,21,751,751);

//      MeanValues.flush(); 
    }
    BtnRun.display();
    
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
void DetailsPanel()  // Details panel controls
{
    background(bgDetails);
    image(Grid,57,21);
    image(Xscale,30,775);
    image(Yscale,10,10);    
    Plot();
    
    BtnSeqR.update();
    if (BtnSeqR.released)
    {
      PanelIndx = 4;
      InputFieldsSequencer();
      background(bgSequencer);
      textFont(CharFont, 15); 
    }
    BtnSeqR.display();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {
//      DetailValues.flush();
//      DetailValues.close();
      exit();
    }
    BtnQuit.display();
    
    BtnSendSpeed.update();
    if (BtnSendSpeed.released)
    {
      // 1 int (range -500 mm/s +500 mm/s)
      DesSpeed = RangeCheckInt(InputSpeed.getValue(), -500, 500);
      InputSpeed.setValue(nf(DesSpeed,3));
      TxIntValue[0] = DesSpeed;
      TxData(0, 'S', 1, 1);
    }
    BtnSendSpeed.display();
    
    BtnStartSeq.update();
    if (BtnStartSeq.released)
    {
      TxData(0, '#', 0, 1);
    }
    BtnStartSeq.display();
    
    BtnSendXY.update();
    if (BtnSendXY.released)
    {
      //2 int ( X, Y) (range -5000 mm +5000 mm)
      DesCoordX = RangeCheckInt(InputCoordX.getValue(), -5000, 5000);
      InputCoordX.setValue(nf(DesCoordX,4));
      DesCoordY = RangeCheckInt(InputCoordY.getValue(), -5000, 5000);
      InputCoordY.setValue(nf(DesCoordY,4));
      TxIntValue[0] = DesCoordX;
      TxIntValue[1] = DesCoordY;
      TxData(0, 'P', 2, 1);
    }
    BtnSendXY.display();
    
    BtnSendDist.update();
    if (BtnSendDist.released)
    {
      // 1 int (range -5000 mm + 5000 mm)
      DesDist = RangeCheckInt(InputDist.getValue(), -5000, 50000);
      InputDist.setValue(nf(DesDist,4));
      TxIntValue[0] = DesDist;
      TxData(0, 'D', 1, 1);
    }
    BtnSendDist.display();
    
    BtnSendReset.update();
    if (BtnSendReset.released)
    {
      StopFlag = true;
      Delay(10);
      TxData(0, '*', 0, 1);
    }
    BtnSendReset.display();
    
    BtnSendHalt.update();
    if (BtnSendHalt.released)
    {
      TxData(0, 'H', 0, 1);
    }
    BtnSendHalt.display();
    
    if (DebugFlag)
    {
      BtnDebugOn.update();
      if (BtnDebugOn.released)
      {
        DebugFlag=false;
        TxIntValue[0] = 0;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOn.display();
    }
    else
    {
      BtnDebugOn.display();
      BtnDebugOff.update();
      if (BtnDebugOff.released)
      {
        DebugFlag=true;
        TxIntValue[0] = 1;
        TxData(0, 'f', 1, 0);
      }
      BtnDebugOff.display();
    }
    
    if (StopFlag)
    {
      BtnStopOn.update();
      if (BtnStopOn.released)
      {
      if (!PreInitRS232Flag)
        {
          StopFlag=false;
        }
      }
      BtnStopOn.display();
    }
    else
    {
      BtnStopOn.display();
      BtnStopOff.update();
      if (BtnStopOff.released)
      {
        StopFlag=true;
      }
      BtnStopOff.display();
    }
    
    BtnSendVersion.update();
    if (BtnSendVersion.released)
    {
      int VerLen = 26;
      TxData(0, 'R', 0, 1);  // ask for all parameters
      Delay(VerLen);         // wait for data to be received
      
      if (PreInitRS232Flag)
      {
        SimulationRxVer();      // simulation
      }
    
      if (RxData('R',VerLen))
      {
        for (i=HeadLen; i < VerLen+HeadLen; i++)
        {
          Ver[i-HeadLen]= (char)(RxBuff[i]);
        }
      }
    }
    textAlign(RIGHT);
    String VerS = new String(Ver);
    textFont(CharFont, 15); 
    text(VerS, 1148, 672); 
    BtnSendVersion.display();
    
    KnobSegment(); 
 //   GaugeAngle();
    GaugeCurrentL();
    GaugeCurrentR();
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
void SequencerPanel()  // Sequencer panel controls
{
    background(bgSequencer);
    
    textFont(CharFont, 8); 
    
    BtnConfig.update();
    if (BtnConfig.released)
    {
      PanelIndx = 2;
      InputFieldsConfig();
      background(bg);
      textFont(CharFont, 15); 
    }
    BtnConfig.display();
    
    BtnDet.update();
    if (BtnDet.released)
    {
      PanelIndx = 3;
      InputFieldsDetails();
      background(bgDetails);
      textFont(CharFont, 15); 
      DefineDetailsGrid();
      Grid = get(57,21,751,751);
    }
    BtnDet.display();
    
     
    BtnSendCfgLoad.update();
    if (BtnSendCfgLoad.released)
    {
      LoadCfg();
    }
    BtnSendCfgLoad.display();
    
    BtnSendCfgSave.update();
    if (BtnSendCfgSave.released)
    {
      SaveCfg();
    }
    BtnSendCfgSave.display();
    
 
textFont(FixFont, 15); 
textAlign(LEFT);
int TextX = 700;
int TextY = 480;
int TextS = 15;
// text("Sequencer code description",TextX,TextY+TextS*0);
text("Code Meaning Description                         A   B   C",TextX,TextY+TextS*1);
text("0    stop    end of sequence                            ",TextX,TextY+TextS*2);
text("1    Vel     keep angle-set speed                V      ",TextX,TextY+TextS*3);
text("2    Dist    keep angle and speed-set distance   V   D   ",TextX,TextY+TextS*4);
text("3    Angle   keep speed-set angle                V   Phi ",TextX,TextY+TextS*5);
text("4    Angle   keep speed-set angle toward X, Y    V   X   Y",TextX,TextY+TextS*6);
text("5    Speed   keep speed-walk toward X, Y         V   X   Y",TextX,TextY+TextS*7);
text("6    Delay   wait n x 50ms                       Time     ",TextX,TextY+TextS*8);

text("Units",TextX,TextY+TextS*10);
text("  Angle=deg, Speed=mm/s, X-Y=mm, Delay=n x 50ms",TextX,TextY+TextS*11);

textFont(CharFont, 15); 

      fill(255,255,255);
      
/*   if (BtnRun.released)  
    {
      PanelIndx = 1;
      InputFieldsRun();
      background(bg);
      textFont(CharFont, 15); 
      DefineMainGrid();
      Grid = get(57,21,751,751);
    }
    BtnRun.display();
*/
    
    ReleasedFlag = false;
}


/*-----------------------------------------------------------------------------*/
void KnobSegment()  // draw knob index
{
  float KnobX = 1162;
  float KnobY = 333;
  float KnobSegLength = 50;
  float KnobDx = mouseX - KnobX;
  float KnobDy = mouseY - KnobY;
  int Base = 3;
  pushMatrix();
  translate(KnobX, KnobY);
  if (mouseX >= KnobX-KnobSegLength && mouseX <= KnobX+KnobSegLength && 
      mouseY >= KnobY-KnobSegLength && mouseY <= KnobY+KnobSegLength &&
      mousePressed)
    {
      KnobAngle = atan2(KnobDy, KnobDx);  
    }
   rotate(KnobAngle);
   strokeWeight(7.0);
   stroke(67,85,100);
   triangle(0,-Base,0,Base,KnobSegLength,0);
   popMatrix();
   KnobAngle1=degrees(KnobAngle+(PI/2));
   textAlign(CENTER);
   text(nf(KnobAngle1,0,1), KnobX,KnobY+115);
   DesAngle = KnobAngle1;
}

/*-----------------------------------------------------------------------------*/
void GaugeAngle()
{
  float GaugeX = 950;
  float GaugeY = 333;
  float GaugeSegLength = 60;
  float Angle1 = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
   rotate(radians(MesAngle-90));
   strokeWeight(3.0);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   Angle1 = (MesAngle);
//      Angle1 = degrees(MesAngle+(PI/2));
   textAlign(CENTER);
   text(nf(Angle1,0,1), GaugeX,GaugeY+112);
}

/*-----------------------------------------------------------------------------*/
void GaugeSpeed()
{
  float GaugeX = 950;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Speed1;
  float MinSpeed=-500;
  float MaxSpeed=500;
  float Speed = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Speed = MesSpeed;
  if (Speed > 500) Speed = 500;
  if (Speed < -500) Speed = -500;
  Speed1 = Speed * (300 / (MaxSpeed-MinSpeed));
  Speed1=radians(Speed1-90);
   rotate((Speed1));
   strokeWeight(3.0);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Speed,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
void GaugeCurrent()
{
  float GaugeX = 1168;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = Current * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Current,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
void GaugeCurrentR()
{
  float GaugeX = 1168;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = CurrentR * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(CurrentR,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
void GaugeCurrentL()
{
  float GaugeX = 950;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = CurrentL * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(CurrentL,0,1), GaugeX,GaugeY+105);
}

