/* ////////////////////////////////////////////////////////////////////////////
** File:      dsNavConConsole.pde
 VerCon[] = "dsNavConConsolle 0.9.0 by Guiott 05-09";
 Author:    Guido Ottaviani-->g.ottaviani@mediaprogetti.it<--
** Description: navigation control board remote consolle   
**
-------------------------------------------------------------------------------
Copyright 2009 Guido Ottaviani
g.ottaviani@mediaprogetti.it

    dsNavConConsole is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dsNavConConsole is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with dsNavConConsole.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------    
/////////////////////////////////////////////////////////////////////////////*/
import processing.serial.*;
import interfascia.*;

// input text fields
GUIController GuiRun;
IFTextField InputSpeed;
IFTextField InputDist;
IFTextField InputCoordX;
IFTextField InputCoordY;

GUIController GuiConfig;
IFTextField InputSpeed1Kp;
IFTextField InputSpeed1Ki;
IFTextField InputSpeed1Kd;
IFTextField InputSpeed2Kp;
IFTextField InputSpeed2Ki;
IFTextField InputSpeed2Kd;
IFTextField InputAngleKp;
IFTextField InputAngleKi;
IFTextField InputAngleKd;
IFTextField InputDistKp;
IFTextField InputDistKi;
IFTextField InputDistKd;
IFTextField InputAxle;
IFTextField InputWheel1;
IFTextField InputWheel2;
IFTextField InputCpr;
IFTextField InputGear;
IFTextField InputRS232bps;
IFTextField InputRS232Com;

GUIController GuiConfig2;
IFTextField InputMGXmin;
IFTextField InputMGXmax;
IFTextField InputMGYmin;
IFTextField InputMGYmax;
IFTextField InputMGXstep;
IFTextField InputMGYstep;
IFTextField InputMGXSteps;
IFTextField InputMGYSteps;
IFTextField InputMGset;

IFTextField InputDGXmin;
IFTextField InputDGXmax;
IFTextField InputDGYmin;
IFTextField InputDGYmax;
IFTextField InputDGXstep;
IFTextField InputDGYstep;
IFTextField InputDGXSteps;
IFTextField InputDGYSteps;
IFTextField InputDGset;
IFTextField InputCycle;

// buttons
ImageButtons BtnQuit;
ImageButtons BtnRS232;
ImageButtons BtnConfig;
ImageButtons BtnRun;
ImageButtons BtnDet;
ImageButtons BtnSeqL;
ImageButtons BtnSeqR;
ImageButtons BtnSendSpeed;
ImageButtons BtnSendXY;
ImageButtons BtnSendDist;
ImageButtons BtnSendHalt;
ImageButtons BtnSendReset;
ImageButtons BtnSendVersion;

ImageButtons BtnSendCfgKSpeed1;
ImageButtons BtnSendCfgKSpeed2;
ImageButtons BtnSendCfgKAngle;
ImageButtons BtnSendCfgKDist;
ImageButtons BtnSendCfgWheels;
ImageButtons BtnSendCfgKvel;
ImageButtons BtnSendCfgRS232;
ImageButtons BtnSendCfgSave;
ImageButtons BtnSendCfgLoad;
ImageButtons BtnDebugOff;
ImageButtons BtnDebugOn;
ImageButtons BtnStopOff;
ImageButtons BtnStopOn;
ImageButtons BtnSendError;
ImageButtons BtnStartSeq;

ImageButtons BtnSendMainGrid;
ImageButtons BtnSendMainSet;
ImageButtons BtnSendDetailGrid;
ImageButtons BtnSendDetailSet;
ImageButtons BtnSendCycle;

// PrintWriter MeanValues;
// PrintWriter DetailValues;

// other images
PImage bg;
PImage bgConfig;
PImage bgDetails;
PImage bgSequencer;
PImage Grid;
PImage BlankGrid;
PImage LedRedOn;
PImage LedRedOff;
PImage LedGreenOn;
PImage LedGreenOff;
PImage LedYellowOn;
PImage LedYellowOff;
PImage Xscale;
PImage Yscale;

// gauges
float KnobAngle = -PI/2;
float KnobAngle1 = -PI/2;
int DesSpeed = 0;
int MesSpeed = 0;
float Current = 0;
float CurrentR = 0;
float CurrentL = 0;
float DesAngle = 0;
float DesAnglePrev = 0;
float MesAngle = 0;

int PanelIndx = 1;
boolean ReleasedFlag = false;

int Cycle = 100;
int CyclePeriod;

int RelX = 432;
int RelY = 397;
int RelX0 = 57;
int Ysize = 750;
int Xsize = 750;
int RelY0 = 21 + Ysize;

int i = 0;
float PrevX = 0;
float PrevY = 0;
float DeltaX = 0;
float DeltaY = 0;
float Xpos = 0;
float Ypos = 0;
float Distance = 0;
float DeltaDist = 0;
float PrevXtmp = 0;      // just for simulation
float PrevYtmp = 0;      // just for simulation

int DesDist = 0;
int DesCoordX = 0;
int DesCoordY = 0;

int TxPeriod = 500;
int TxTimer;
boolean BlinkFlag;
boolean TxFlag = false;

Serial RS232Port;
int RS232ComPort = 99;
int RS232Bps;

String[] StrCfg = new String[38];  // config string
String[] SerialList = new String[0];  // declare an empty string for serial ports list 
byte[] TxBuff = new byte[32];  // Transmission buffer
int TxHeadLen = 4;             // TX header lenght
int[] TxIntValue = new int[8]; // int value buffer

int IdleCount = 0;
int IdleTime = 0;
int IdleTimeP = 0;

float CharTime = (0.2); // time period in ms for a char sent on RS232

int[] RxBuff = new int[32];

int Err = 0;
int HeadLen = 4;    // RX-TX header length

char Ver[] = new char[32];

PFont CharFont;
PFont FixFont;

boolean DebugFlag = false;
int ErrorCode = 0;
int IdlePerc;

int MaxSpeedData = 750;
int Max = 750;
int MaxYvalue = 500;
int Yoffset = Ysize/4;
int[] Speed1 = new int[MaxSpeedData+10]; // Y axis graph data for first value
int[] Speed2 = new int[MaxSpeedData+10]; // Y axis graph data for second value
int[] Speed0 = new int[MaxSpeedData+10]; // Y axis graph data for mean value
int SpeedDataPtr = 1;                 // array index pointer
int SpeedDataStep = 1;                // X axis step
float Xk;                             // X costant multiplier to draw graph
float Yk;                             // Y costant multiplier to draw graph
float Xkofst;                         // X offset to draw graph
float Ykofst;                         // Y offset to draw graph

int MainGridMinX;
int MainGridMaxX;
int MainGridMinY;
int MainGridMaxY;
int MainGridXstep;
int MainGridYstep;
int MainGridXstepSmall;
int MainGridYstepSmall;
int MainGridFlag;
int MainGridSet;

int DetailGridMinX;
int DetailGridMaxX;
int DetailGridMinY;
int DetailGridMaxY;
int DetailGridXstep;
int DetailGridYstep;
int DetailGridXstepSmall;
int DetailGridYstepSmall;
int DetailGridFlag;
int DetailGridSet;
float Step;
  
// it will be set false after RS232 configuration to start real communication
boolean PreInitRS232Flag = true;  
boolean StopFlag = true;

/* in order to allow usage of the applet in a browser as a demo simulation,
   some functions that access to HW resources must me disabled, otherwise a
   security violation error occurs.
*/
boolean SimulationDrawFlag = false;
boolean SimulationCfgFlag = false;
boolean SimulationRS232Flag = false;

/*/////////////////////////////////////////////////////////////////////////////*/

void setup()
{
  int ii = 0;
  size(1295, 815);
  smooth();

  CharFont = loadFont("HelveticaNeue-Bold-48.vlw"); 
  fill(255,255,255);
  textFont(CharFont, 16); 
  textAlign(CENTER);
  
  FixFont = loadFont("Courier-Bold-48.vlw"); 
  
  bg = loadImage("Panel.gif");
  bgConfig = loadImage("ConfigPanel.gif");
  bgDetails = loadImage("DetailsPanel.gif");
  bgSequencer = loadImage("SequencerPanel.gif");
  background(bg);
  InputFieldsDefinition();
  LoadCfg();
//  MeanValues = createWriter("Mean.txt"); 
//  MeanValues.print("*****************"+day()+"-"+month()+"-"+year()+"*****************"); 
//  MeanValues.println();
//  MeanValues.flush();
  
//  DetailValues = createWriter("Detail.txt"); 
//  DetailValues.print("*****************"+day()+"-"+month()+"-"+year()+"*****************"); 
//  DetailValues.println();
//  DetailValues.flush();
  
  DefineMainGrid();
 //  BlankGrid = get(57,21,751,751);
  LedRedOn = loadImage("LedRedOn.gif");
  LedRedOff = loadImage("LedRedOff.gif");
  LedGreenOn = loadImage("LedGreenOn.gif");
  LedGreenOff = loadImage("LedGreenOff.gif");
  LedYellowOn = loadImage("LedYellowOn.gif");
  LedYellowOff = loadImage("LedYellowOff.gif");
  
  DefineButtons();
  
  strokeWeight(3.0);
  stroke(255,0,0);
  
  if (! SimulationRS232Flag)
  {
    i=0;
    while(i< Serial.list().length)
    {
      SerialList = (append(SerialList, Serial.list()[i]));
      i++;
    }
  }
  else
  {
    i=1;
    while(i < 5)
    {
      SerialList = (append(SerialList, "COM"+i));
      i++;
    }
    SerialList = (append(SerialList, "All COM ports are simulated"));
  }
}

// main loop --------------------------------------------------------------------
void draw()
{ 
  switch (PanelIndx)
  {
    case 1:
      MainPanel();
    break;
    
    case 2:
      ConfigPanel();
    break;
    
    case 3:
      DetailsPanel();
    break;
    
    case 4:
      SequencerPanel();
    break;
    
    default:
      MainPanel(); 
    break;
  }

  image(LedYellowOff,1169,700);
  IdleCount++;     // count idle period in ms
  if(IdleCount > 100)
  {
    IdleCount = 0;
    IdleTimeP = millis()-IdleTime;
    IdleTime=millis();
  }
  textAlign(LEFT);
  text(IdleTimeP/100, 1200, 760);
  textAlign(CENTER);
  text(Err, 1240, 760);
  text(IdlePerc,1177,760);
  
  if ((millis()-Cycle) > CyclePeriod)  // slow loop start------------------------
  {
    Cycle = millis();
    if (SimulationDrawFlag)          // simulation
    {
      SimulationDrawing();
    }
    else
    {
        switch (PanelIndx)
        {
          case 1:  // main panel displays on graph and gaugesthe mean values and the position
            if (!PreInitRS232Flag && !StopFlag)
            {
              TxData(0, 'A', 0, 3);  // ask for all parameters
              Delay(3);              // wait for data to be received
              if (RxData('A',11))
              {// two bytes -> i int
                MesSpeed = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
                Current = (float)((RxBuff[HeadLen+2] << 8) + (RxBuff[HeadLen+3]));
                Xpos = Int16toint32((RxBuff[HeadLen+4] << 8) + (RxBuff[HeadLen+5]));
                Ypos = Int16toint32((RxBuff[HeadLen+6] << 8) + (RxBuff[HeadLen+7]));
                MesAngle = Int16toint32((RxBuff[HeadLen+8] << 8) + (RxBuff[HeadLen+9]));
                IdlePerc = RxBuff[HeadLen+10];
 //               MeanValues.print(hour()+":"+minute()+":"+second()+"    "+MesSpeed+" "+Current+" "+Xpos+" "+Ypos+" "+MesAngle+" "+IdlePerc); 
 //               MeanValues.println();
                if (SimulationDrawFlag)          // simulation
                {
                  Current = abs(DesSpeed*2);                          // just for simulation
                  MesSpeed = DesSpeed;                                // just for simulation 
                  MesAngle = KnobAngle;                               // just for simulation     
                }   

              }
            }
            Graph(Xpos,Ypos);
          break;
    
          case 2:

          break;
    
          case 3:  // details panel displays on graph and gauges detailed valued
            if (!PreInitRS232Flag && !StopFlag)
            {
              TxData(0, 'a', 0, 3);  // ask for all parameters
              Delay(3);              // wait for data to be received
              if (RxData('a',12))
              {// two bytes -> i int
                Speed1[SpeedDataPtr] = Int16toint32(((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1])));
                Speed2[SpeedDataPtr] = Int16toint32(((RxBuff[HeadLen+2] << 8) + (RxBuff[HeadLen+3])));
//                println(RxBuff[HeadLen]+" "+RxBuff[HeadLen+1]+" "+RxBuff[HeadLen+2]+" "+RxBuff[HeadLen+3]);
               
                Speed1[SpeedDataPtr] = (int)(Speed1[SpeedDataPtr] * Yk);
                Speed2[SpeedDataPtr] = (int)(Speed2[SpeedDataPtr] * Yk);
 //               Speed0[SpeedDataPtr] = (Speed1[SpeedDataPtr] + Speed2[SpeedDataPtr])/2;
                CurrentR = (float)((RxBuff[HeadLen+4] << 8) + (RxBuff[HeadLen+5]));     
                CurrentL = (float)((RxBuff[HeadLen+6] << 8) + (RxBuff[HeadLen+7])); 
 //               DetailValues.print(hour()+":"+minute()+":"+second()+"    "+Speed1[SpeedDataPtr]+" "+Speed2[SpeedDataPtr]+" "+CurrentR+" "+CurrentL); 
//                DetailValues.println();
              }
            }
            if (!StopFlag)  SpeedDataPtr+=SpeedDataStep;
          break;
          
          case 4:

          break;
    
          default:
            Graph(Xpos,Ypos);
          break;
        }
    }
    
    if (DesAnglePrev != DesAngle)
    {
      DesAnglePrev = DesAngle;
      TxIntValue[0] = (int)(DesAngle);
      TxData(0, 'O', 1, 1);
    }
    
    if (BlinkFlag)
    {
      BlinkFlag = false;
    }
    else 
    {
      BlinkFlag = true;
    }
  }                                    // slow loop end--------------------------
  
  LedBlink();
}
/*/////////////////////////////////////////////////////////////////////////////*/

/*-----------------------------------------------------------------------------*/
boolean RxData(char Cmd,int Len)
{
  int ChkSum = 0;

  if (! PreInitRS232Flag)  // RS232 initialized
  {
        if (RS232Port.available() <= 0)
        {
          RS232Port.clear();
          textAlign(LEFT);
          text("RX error:",1040,710);
          text("TMO - No RX",1040,725);;
          textAlign(CENTER);
          Err++;
          return false;
        }
        else
        {
          for (i=0; i < Len+HeadLen+1; i++)  // loop for all data expected and only for that
          {
            RxBuff[i] = (RS232Port.read());
          }
        }
      
      if (RxBuff[0] != '@')
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("No Header",1040,725);
        text("Expected: @",1040,740);
        text("Found: " + (char)(RxBuff[0]),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      else if (RxBuff[2] != Cmd)
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("Wrong CMD",1040,725);
        text("Expected: "+Cmd,1040,740);
        text("Found: " + (char)(RxBuff[2]),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      else if (RxBuff[3] != (Len+1))
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("Wrong LEN",1040,725);
        text("Expected: "+Len,1040,740);
        text("Found: " + (RxBuff[3]-1),1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      
      for (i=0; i < Len+HeadLen; i++)  //  ChkSum excluded
      {
        ChkSum += (char)(RxBuff[i]);
      }
      ChkSum = ChkSum % 256;
      if (RxBuff[i] != ChkSum)
      {
        RS232Port.clear();
        textAlign(LEFT);
        text("RX error:",1040,710);
        text("ChkSum err",1040,725);
        text("Expected: "+RxBuff[i],1040,740);
        text("Found: " + ChkSum,1040,755);
        textAlign(CENTER);
        Err++;
        return false;
      }
      image(LedYellowOn,1169,700);
      return true;
  }
  return false;
}
    
/*-----------------------------------------------------------------------------*/
void Delay(int Bytes)
{
   /* wait for data to be received for a time (in ms) proportional to 
      num of bytes: data bytes + TX overhead + RX overhead (Bytes+5+5)
   */
   Bytes += 10;
   int Del= (int)((CharTime * Bytes) + 0.5);
   int StartDelay = millis();
   while ((millis()-StartDelay) < Del);
}

/*-----------------------------------------------------------------------------*/
void LedBlink()
{
  if (BlinkFlag)  // blink green (cycle) led
  {
   image(LedGreenOn,1200,700);
  }
  else
  {
   image(LedGreenOff,1200,700);
  }
    
  if (TxFlag)  // blink red (TX) led
  {
    image(LedRedOn,1230,700);
  }
  else
  {
    image(LedRedOff,1230,700);
    TxTimer = millis();
  }
  if ((millis() - TxTimer) >= TxPeriod)
  {
    TxTimer = millis();
    TxFlag = false;
  }
}

/*-----------------------------------------------------------------------------*/
void Graph(float Xcoord, float Ycoord)
{
    /* following statements are needed to translate the reference system from
    0(top-left), 750(bottom right) to  bottom-left, top-right scale values
    */
    pushMatrix();
    translate(RelX,RelY);
    rotate(-HALF_PI);
    strokeWeight(3);
    stroke(255,0,0);
    Xcoord = Xcoord / 10000 * 750;
    Ycoord = Ycoord / 10000 * 750;
    // rotating system switches X with Y
    line(Ycoord, Xcoord, PrevY, PrevX);
    PrevX = Xcoord;
    PrevY = Ycoord;
    popMatrix();
}

/*-----------------------------------------------------------------------------*/  
int RangeCheckInt(String Data, int Min, int Max)
{
    int IntNum = 0;
    if (Data.length() != 0)
    {
      IntNum = Integer.parseInt(Data);
      if (IntNum < Min) IntNum = Min;
      if (IntNum > Max) IntNum = Max;
    }
    return IntNum;
}


/*-----------------------------------------------------------------------------*/  
float RangeCheckFloat(String Data, float Min, float Max)
{
    float FloatNum = 0;
    if (Data.length() != 0)
    {
      FloatNum = Float.parseFloat(Data);
      if (FloatNum < Min) FloatNum = Min;
      if (FloatNum > Max) FloatNum = Max;
      TxFlag = true;
    }
    return FloatNum;
}

/*-----------------------------------------------------------------------------*/  
void TxData(int Id, int Cmd, int ValueLen, int IntFlag)
{
/* Transmit a string toward dsNavCon board
   for a detailed description of protocol, see descrEng.txt in dsPID33 folder
*/
  int TxBuffCount;
  int ChkSum = 0;
  int CmdLen = 0;
  
  if (PreInitRS232Flag)  // RS232 not ready
  {
    return;
  }
  
  if (IntFlag == 0)  // byte value
  {
    CmdLen = ValueLen;  
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*2)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  if (IntFlag == 1)  // integer value
  {
    CmdLen = ValueLen*2;          // 1 int value = 2 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*2)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*2)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  if (IntFlag == 2) // long value
  {
    CmdLen = ValueLen*4;        // 1 long value = 4 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*4)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 24);
      TxBuff[(TxBuffCount*4)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount] >> 16);
      TxBuff[(TxBuffCount*4)+TxHeadLen+2] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*4)+TxHeadLen+3] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  TxBuff[0] = (byte)('@');
  TxBuff[1] = (byte)(Id);
  TxBuff[2] = (byte)(Cmd);
  TxBuff[3] = (byte)(CmdLen+1);  // included CheckSum

  for (i=0;i<(TxHeadLen+CmdLen);i++) 
  {
   ChkSum += TxBuff[i];
  }
  TxBuff[TxHeadLen+CmdLen] = (byte)(ChkSum);
  
  for (i=0;i<(TxHeadLen+CmdLen+1);i++) 
  {
    RS232Port.write(TxBuff[i]);
//    println(TxBuff[i]);
   }
      
  if (IntFlag != 3) TxFlag = true; // avoid to blink TX led for continuos send
}

/*-----------------------------------------------------------------------------*/
void LoadCfg()  // Load data from config.txt file
{
  if (! SimulationCfgFlag)
  {
    if (loadStrings("config.txt") != null)
    {
      StrCfg = loadStrings("config.txt");
    }
    else 
    {
      CfgDefault();
      saveStrings("config.txt",StrCfg);
    }
  }
  else
  {
    CfgDefault();
  }
  
  FillTextFields();
}

/*-----------------------------------------------------------------------------*/
void CfgDefault()
{//if file config.txt is not present a new one is created with defaults
      StrCfg[0] = "6000";
      StrCfg[1] = "2000";
      StrCfg[2] = "200";
      StrCfg[3] = "6000";
      StrCfg[4] = "2000";
      StrCfg[5] = "200";
      StrCfg[6] = "9999";
      StrCfg[7] = "0";
      StrCfg[8] = "1";
      StrCfg[9] = "9999";
      StrCfg[10] = "0";
      StrCfg[11] = "1";
      StrCfg[12] = "1852222";
      StrCfg[13] = "5061455";
      StrCfg[14] = "5061455";
      StrCfg[15] = "13145171";
      StrCfg[16] = "13145171";
      StrCfg[17] = "57600";
      StrCfg[18] = "0";
  
      StrCfg[19] =  "-5000";
      StrCfg[20] =  "5000";
      StrCfg[21] =  "-5000";
      StrCfg[22] =  "5000";
      StrCfg[23] =  "10";
      StrCfg[24] =  "10";
      StrCfg[25] =  "50";
      StrCfg[26] =  "50";
      StrCfg[27] =  "0";

      StrCfg[28] =  "-150";
      StrCfg[29] =  "0";
      StrCfg[30] =  "-500";
      StrCfg[31] =  "500";
      StrCfg[32] =  "15";
      StrCfg[33] =  "20";
      StrCfg[34] =  "100";
      StrCfg[35] =  "75";
      StrCfg[36] =  "3";
      StrCfg[37] =  "200";
    
}

/*-----------------------------------------------------------------------------*/
void FillTextFields()
{
       textFont(CharFont, 10); 
       InputSpeed1Kp.setValue(StrCfg[0]);
       InputSpeed1Ki.setValue(StrCfg[1]);
       InputSpeed1Kd.setValue(StrCfg[2]);
       InputSpeed2Kp.setValue(StrCfg[3]);
       InputSpeed2Ki.setValue(StrCfg[4]);
       InputSpeed2Kd.setValue(StrCfg[5]);
       InputAngleKp.setValue(StrCfg[6]);
       InputAngleKi.setValue(StrCfg[7]);
       InputAngleKd.setValue(StrCfg[8]);
       InputDistKp.setValue(StrCfg[9]);
       InputDistKi.setValue(StrCfg[10]);
       InputDistKd.setValue(StrCfg[11]);
       InputAxle.setValue(StrCfg[12]);
       InputWheel1.setValue(StrCfg[13]);
       InputWheel2.setValue(StrCfg[14]);
       InputCpr.setValue(StrCfg[15]);
       InputGear.setValue(StrCfg[16]);
       InputRS232bps.setValue(StrCfg[17]);
       InputRS232Com.setValue(StrCfg[18]);
       
       InputMGXmin.setValue(StrCfg[19]);
       InputMGXmax.setValue(StrCfg[20]);
       InputMGYmin.setValue(StrCfg[21]);
       InputMGYmax.setValue(StrCfg[22]);
       InputMGXstep.setValue(StrCfg[23]);
       InputMGYstep.setValue(StrCfg[24]);
       InputMGXSteps.setValue(StrCfg[25]);
       InputMGYSteps.setValue(StrCfg[26]);
       InputMGset.setValue("0");
       
       InputDGXmin.setValue(StrCfg[28]);
       InputDGXmax.setValue(StrCfg[29]);
       InputDGYmin.setValue(StrCfg[30]);
       InputDGYmax.setValue(StrCfg[31]);
       InputDGXstep.setValue(StrCfg[32]);
       InputDGYstep.setValue(StrCfg[33]);
       InputDGXSteps.setValue(StrCfg[34]);
       InputDGYSteps.setValue(StrCfg[35]);
       InputDGset.setValue("0");
       InputCycle.setValue(StrCfg[37]);
       textFont(CharFont, 15); 
      
      MainGridMinX = Integer.parseInt(StrCfg[19]);
      MainGridMaxX = Integer.parseInt(StrCfg[20]);
      MainGridMinY = Integer.parseInt(StrCfg[21]);
      MainGridMaxY = Integer.parseInt(StrCfg[22]);
      MainGridXstep = Integer.parseInt(StrCfg[23]);
      MainGridYstep = Integer.parseInt(StrCfg[24]);
      MainGridXstepSmall = Integer.parseInt(StrCfg[25]);
      MainGridYstepSmall = Integer.parseInt(StrCfg[26]);
      MainGridFlag = Integer.parseInt(StrCfg[27]);

      DetailGridMinX = Integer.parseInt(StrCfg[28]);
      DetailGridMaxX = Integer.parseInt(StrCfg[29]);
      DetailGridMinY = Integer.parseInt(StrCfg[30]);
      DetailGridMaxY = Integer.parseInt(StrCfg[31]);
      DetailGridXstep = Integer.parseInt(StrCfg[32]);
      DetailGridYstep = Integer.parseInt(StrCfg[33]);
      DetailGridXstepSmall = Integer.parseInt(StrCfg[34]);
      DetailGridYstepSmall = Integer.parseInt(StrCfg[35]);
      DetailGridFlag = Integer.parseInt(StrCfg[36]); 
      CyclePeriod = Integer.parseInt(StrCfg[37]);
 }
       
/*-----------------------------------------------------------------------------*/
void SaveCfg()  // Save current data to config.txt file
{
      StrCfg[0] = InputSpeed1Kp.getValue();
      StrCfg[1] = InputSpeed1Ki.getValue();
      StrCfg[2] = InputSpeed1Kd.getValue();
      StrCfg[3] = InputSpeed2Kp.getValue();
      StrCfg[4] = InputSpeed2Ki.getValue();
      StrCfg[5] = InputSpeed2Kd.getValue();
      StrCfg[6] = InputAngleKp.getValue();
      StrCfg[7] = InputAngleKi.getValue();
      StrCfg[8] = InputAngleKd.getValue();
      StrCfg[9] = InputDistKp.getValue();
      StrCfg[10] = InputDistKi.getValue();
      StrCfg[11] = InputDistKd.getValue();
      StrCfg[12] = InputAxle.getValue();
      StrCfg[13] = InputWheel1.getValue();
      StrCfg[14] = InputWheel2.getValue();
      StrCfg[15] = InputCpr.getValue();
      StrCfg[16] = InputGear.getValue();
      StrCfg[17] = InputRS232bps.getValue();
      StrCfg[18] = InputRS232Com.getValue();
      
      StrCfg[19] =  nf(MainGridMinX,0);
      StrCfg[20] =  nf(MainGridMaxX,0);
      StrCfg[21] =  nf(MainGridMinY,0);
      StrCfg[22] =  nf(MainGridMaxY,0);
      StrCfg[23] =  nf(MainGridXstep,0);
      StrCfg[24] =  nf(MainGridYstep,0);
      StrCfg[25] =  nf(MainGridXstepSmall,0);
      StrCfg[26] =  nf(MainGridYstepSmall,0);
      StrCfg[27] =  nf(MainGridFlag,0);

      StrCfg[28] =  nf(DetailGridMinX,0);
      StrCfg[29] =  nf(DetailGridMaxX,0);
      StrCfg[30] =  nf(DetailGridMinY,0);
      StrCfg[31] =  nf(DetailGridMaxY,0);
      StrCfg[32] =  nf(DetailGridXstep,0);
      StrCfg[33] =  nf(DetailGridYstep,0);
      StrCfg[34] =  nf(DetailGridXstepSmall,0);
      StrCfg[35] =  nf(DetailGridYstepSmall,0);
      StrCfg[36] =  nf(DetailGridFlag,0);
      StrCfg[37] =  nf(CyclePeriod,0);
      
      if (! SimulationCfgFlag)
      {
        saveStrings("config.txt",StrCfg);
      }
}

/*-----------------------------------------------------------------------------*/
int Int16toint32 (int Int16)
{
// data coming from micro are in 16 bit int, needs to be converted in 32 bit int
        if (Int16 > 32768)
        {
          Int16 -= 65536;  
        }
        
        return Int16;
}

/*-----------------------------------------------------------------------------*/
void Plot ()
{
  int ind = 1;
  int ptr;
  int IndPrev;
  int MaxInd;
  float StepTmp;
  pushMatrix();
  translate(RelX0,RelY-(Yoffset));
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(255,255,0);
  // rotating system switches X with Y
  
  if (Step >= 1)
  {
     MaxInd = (int)(MaxSpeedData/Step);
     StepTmp = Step;
  }
  else
  {
    MaxInd = MaxSpeedData;
    StepTmp = 1;
  }
  
  if (SpeedDataPtr>=MaxInd)
  {
    SpeedDataPtr=0;
  }
  
  IndPrev = (int)(StepTmp);
  for (ind=1; ind < MaxInd; ind++)
  {
    ptr=(ind+SpeedDataPtr) % MaxInd;
    if (ptr>0)
    {
      line((Speed1[ptr-1]), IndPrev, (Speed1[ptr]), ind*StepTmp+1);
      IndPrev = (int)(ind*StepTmp);
    }
  }
  popMatrix();

  pushMatrix();
  translate(RelX0,RelY+Yoffset);
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(0,0,255);
  // rotating system switches X with Y

  IndPrev = (int)(StepTmp);
  for (ind=1; ind < MaxInd; ind++)
  {
    ptr=(ind+SpeedDataPtr) % MaxInd;
    if (ptr>0)
    {
      line((Speed2[ptr-1]), IndPrev, (Speed2[ptr]), ind*StepTmp+1);
      IndPrev = (int)(ind*StepTmp);
    }
  }
  popMatrix();
  
  /*
  pushMatrix();
  translate(RelX0,RelY);
  rotate(-HALF_PI);
  strokeWeight(3);
  stroke(255,0,0);
  // rotating system switches X with Y
  
  for (ind=1; ind < MaxSpeedData; ind++)
  {
    ptr=(ind+SpeedDataPtr) % (MaxSpeedData);
    if (ptr<(MaxSpeedData-1))
    {
      line((Speed0[ptr] * Yk), ind, (Speed0[ptr+1] * Yk), ind+1);
    }

  }
  popMatrix();
 */
}

void DefineMainGrid ()
{
   DefineGrid(MainGridMinX, MainGridMaxX, MainGridMinY, MainGridMaxY, MainGridXstep, 
               MainGridYstep, MainGridXstepSmall, MainGridYstepSmall, MainGridFlag);
}

void DefineDetailsGrid ()
{
  int ii;
  int MaxInd;
  
  DefineGrid(DetailGridMinX, DetailGridMaxX, DetailGridMinY, DetailGridMaxY, 
               DetailGridXstep, DetailGridYstep, DetailGridXstepSmall, 
               DetailGridYstepSmall, DetailGridFlag);
               
   Yk = Yk/2;
   
/*  // When scale changes, the plot buffer is flushed
  for (ii=1; ii< MaxSpeedData; ii++)
  {
    Speed1 [ii] = 0;
  }
  
     for (ii=1; ii< MaxSpeedData; ii++)
  {
    Speed2 [ii] = 0;
  }
*/

/*  //////////////// Debug
  if (Step >= 1)
  {
     MaxInd = (int)(MaxSpeedData/Step);
  }
  else
  {
    MaxInd = MaxSpeedData;
  }

  for (ii=1; ii< (MaxInd); ii++)
  {
    Speed1 [ii] = ((int) (sin(radians(ii))*(400)))*Yoffset/MaxYvalue;
  }
  
     for (ii=1; ii< MaxInd; ii++)
  {
    Speed2 [ii] = ((int) (cos(radians(ii))*(400)))*Yoffset/MaxYvalue;
  }
  //////////////// Debug */
}

/*-----------------------------------------------------------------------------
void serialEvent(Serial p) 
{ 
    RxBuff[RxBuffCount] = (byte)(RS232Port.read());
        println(RxBuffCount+ " " +(char)(RxBuff[RxBuffCount]));
    RxBuffCount++;
}
*/
